import java.io.*;


class JavaRockey
{
		// // Definitions of diratrpri(directory attribute) and fileatrpri(file attribute)
	public static int FILEATTR_NORMAL			=	0x00;   // Normal data file
	public static int FILEATTR_EXEC				=	0x10;	// Executable
	public static int FILEATTR_DIR				=	0x20;	// Directory
	public static int FILEATTR_UPIGNORE			=	0x40;	// If the current security level is already higher than that of the executable -
										// program, the program cannot be executed. 
	public static int FILEATTR_INTERNAL			=	0x80;	// File used by internal program and can not be operated externally. 
										// If an executable file is marked as internal,it has hiding property,such files can 
										// be viewed when listing directory only if the super password is verified.

	public static int GET_CARD_INFO				=	0x02000000;
	public static int GET_HARDWARE_INFO			=	0x00FF1C00;
	public static int GET_MANAGER_CODE			=	0x00FF1A00;
	public static int GET_CARD_PRIVILEGE			=	0x00FF2200;
	public static int GET_REMOTE_INFO			=	0x00FF1e00;
	public static int SET_REMOTE_INFO			=	0x00FF1003;
	public static int CHECK_REMOTE_INFO			=	0x01FF1003;
	public static int GET_CURRENT_DIR			=	0x00001800;
	public static int SET_CURRENT_DIR			=	0x0000a400;
	public static int GET_CURRENT_FILE			=	0x00001801;
	public static int SET_CURRENT_FILE			=	0x0100a400;
	public static int GET_PARENT_DIR			=	0x00001802;
	public static int SET_PARENT_DIR			=	0x0000a402;
	public static int LIST_DIR				=	0x0000b200;
	public static int READ_FILE				=	0x0000b000;
	public static int WRITE_FILE				=	0x0000d000;
	public static int FORMAT_CARD				=	0x0000e000;
	public static int CREATE_DIR				=	0x0000e001;
	public static int CREATE_FILE				=	0x0100e001;
	public static int REMOVE_DIR				=	0x0000ee00;
	public static int REMOVE_FILE				=	0x0000ee01;
	public static int RANDOM				=	0x00008400;
	public static int RUN					=	0x03000000;
	public static int CRYPTOTEXT_FILE			=	0x04000000;
	public static int PLAINTEXT_FILE			=	0x05000000;

	public static int DESENC				=	0x00005000;
	public static int DESDEC				=	0x00005100;
	public static int RSAGENKEY				=	0x00003300;
	public static int RSAENC				=	0x00003400;
	public static int RSADEC				=	0x00003500;

	public static int GETFREESPACE				=	0X00003000;
	public static int MODULE_GETFILEFLAG			=	0X00003600;
	public static int MODULE_CRYPTOTEXT_MODFLAG		=	0x00003700;
	public static int MODULE_PLAINTEXT_MODFLAG		=	0x00003800;
	public static int MODULE_ENCRYPT_CONTENT		=	0x00003900;

	public static int SETCOUNTER				=	0x00005700;
	public static int STEPCOUNTER				=	0x00005800;

	public static int CHECK_SUPER_PASS			=	0x00FF1002;
	public static int SET_SUPER_PASS			=	0x00FFF402;
	public static int GET_UPGRADE_REMOTE_PASS		=	0x00FF2000;
	
	
	public static int FILL					=	0x80000000;
	public static int ATR					=	0x80010000;
	public static int VOLUME				=	0x80020000;
	public static int FACTORY_TIME				=	0x80030000;
	public static int HARD_SERIAL				=	0x80040000;
	public static int SHIP_TIME				=	0x80050000;
	public static int COS_VERSION				=	0x80060000;
	public static int ZONE					=	0x80070000;
	public static int AGENT					=	0x80080000;
	public static int USER1					=	0x80090000;
	public static int USER2					=	0x800A0000;
	public static int DIR_ID				=	0x800B0000;
	public static int DIR_CLASS				=	0x800C0000;
	public static int DIR_ATTRIBUTE				=	0x800D0000;
	public static int DIR_PRIVILEGE				=	0x800E0000;
	public static int FILE_NO				=	0x800F0000;
	public static int DIR_NAME				=	0x80100000;
	public static int FILE_ID				=	0x80110000;
	public static int FILE_CLASS				=	0x80120000;
	public static int FILE_ATTRIBUTE			=	0x80130000;
	public static int FILE_PRIVILEGE			=	0x80140000;
	public static int FILE_SIZE				=	0x80150000;
	public static int FILE_NAME				=	0x80160000;
	public static int WRITE_DATA				=	0x80170000;
	public static int READ_DATA				=	0x80180000;
	public static int RUN_DATA				=	0x80190000;
	public static int RANDOM_SIZE				=	0x801A0000;
	public static int REMOTE_TAG				=	0x801B0000;
	public static int REMOTE_PASS				=	0x801C0000;
	public static int UPGRADE_HARD_SERIAL			=	0x801D0000;
	public static int UPGRADE_REMOTE_TAG			=	0x801E0000;
	public static int UPGRADE_REMOTE_PASS			=	0x801F0000;
	public static int REMOTEPASS_STATUS			=	0x80200000;
	public static int SUPERPASS_STATUS			=	0x80210000;
	public static int SUPERPASS_DATA			=	0x80220000;
	public static int FILE_DATA				=	0x80230000;
	public static int RELOAD_FLOATLIBS			=   	0x0000e002;
	public static int RELOAD_RSADESLIBS			=   	0x0000e003;
	public static int ISLOADEDFLOATLIBS			=   	0x0000e004;
	public static int ISLOADEDRSADESLIBS			=   	0x0000e005 ;
	public static int RELOAD_EXTENDFLOATLIBS		=   	0x0000e006;
	public static int ISLOADEXTENDFLOATLIBS			=   	0x0000e007;
	public static int WRITE_HARDSERIAL			=   	0x0000e008;

		//DICST_Des_Data					//Used by DIC_Set
	public static int DES_KEYFILEID				=	0x80240000;
	public static int DES_KEYINDEX				=	0x80250000;
	public static int DES_DATA				=	0x80260000;
		//DICST_After_EncDec_Data				//Used by DIC_Get
	public static int AFTER_ENCDEC_DATA			=	0x80270000;

		//DICST_Rsa_Data					//Used by DIC_Set
	public static int RSA_KEYFILEID				=	0x80280000;
	public static int RSA_DATA				=	0x80290000;

		//DICST_Rsa_GenKey					//Used by Dic_Set
	public static int RSA_PUBKEYID				=	0x802A0000;
	public static int RSA_PUBKEYSIZE			=	0x802B0000;
	public static int RSA_PIVKEYID				=	0x802C0000;

	// ====================================================================
	public static int BY_VALUE				=	0x00000000;
	public static int BY_DOUBLE				=	0x40000000;
	public static int BY_ARRAY				=	0x80000000;
	public static int BY_STRING				=	0xC0000000;
	
	
	// Error code ===========================================================

	// Success
	public static int SCARD_S_SUCCESS 			=	0x00000000;

	// Internal link check failure
	public static int SCARD_F_INTERNAL_ERROR		=	0x80100001;

	// Operation is terminated by user
	public static int SCARD_E_CANCELLED			=	0x80100002;
	
	// Incorrect operation handle
	public static int SCARD_E_INVALID_HANDLE		=	0x80100003;
	
	// Incorrect parameter
	public static int SCARD_E_INVALID_PARAMETER		=	0x80100004;
		
	// Registered startup information lost or invalid 
	public static int SCARD_E_INVALID_TARGET		=	0x80100005;
	
	// Memory not enough for command completion 
	public static int SCARD_E_NO_MEMORY			=	0x80100006;
	
	// Internal overtime
	public static int SCARD_F_WAITED_TOO_LONG		=	0x80100007;

	// User specified buffer is too small, not enough for the return data
	public static int SCARD_E_INSUFFICIENT_BUFFER		=	0x80100008;

	// Unknown card reader
	public static int SCARD_E_UNKNOWN_READER		=	0x80100009;

	// Over user specified time
	public static int SCARD_E_TIMEOUT			=	0x8010000A;

	// Card occupied by other connection
	public static int SCARD_E_SHARING_VIOLATION		=	0x8010000B;

	// No card in the card reader
	public static int SCARD_E_NO_SMARTCARD			=	0x8010000C;

	// Unknown card type
	public static int SCARD_E_UNKNOWN_CARD			=	0x8010000D;

	// Card reader can not complete card eject operation
	public static int SCARD_E_CANT_DISPOSE			=	0x8010000E;

	// Current card does not support user specified communication protocol
	public static int SCARD_E_PROTO_MISMATCH		=	0x8010000F;

	// Card is not ready for receiving commands
	public static int SCARD_E_NOT_READY			=	0x80100010;
	
	// Some variable values are not suitable
	public static int SCARD_E_INVALID_VALUE			=	0x80100011;

	// Operation is terminated by system, it may be necessary to log on again or shut down.
	public static int SCARD_E_SYSTEM_CANCELLED		=	0x80100012;

	// Internal communication error
	public static int SCARD_F_COMM_ERROR			=	0x80100013;

	// Unknown internal error
	public static int SCARD_F_UNKNOWN_ERROR			=	0x80100014;

	// Invalid vendor information
	public static int SCARD_E_INVALID_ATR			=	0x80100015;

	// User attempts to terminate some process not available
	public static int SCARD_E_NOT_TRANSACTED		=	0x80100016;

	// The specifiied card reader is not ready
	public static int SCARD_E_READER_UNAVAILABLE		=	0x80100017;

	// Operation is terminated, service program is allowed to exit
	public static int SCARD_P_SHUTDOWN			=	0x80100018;

	// PCI receiving buffer is too small
	public static int SCARD_E_PCI_TOO_SMALL			=	0x80100019;

	// Card reader drive does not support the current card reader
	public static int SCARD_E_READER_UNSUPPORTED		=	0x8010001A;

	// Card reader driver program can not create an exclusive name, card reader with the same name already exists
	public static int SCARD_E_DUPLICATE_READER		=	0x8010001B;

	// Card is not supported by the current card reader
	public static int SCARD_E_CARD_UNSUPPORTED		=	0x8010001C;

	// Smart card service is not enabled
	public static int SCARD_E_NO_SERVICE			=	0x8010001D;

	// Smart card service is disabled
	public static int SCARD_E_SERVICE_STOPPED		=	0x8010001E;

	// Some unexpected smart card error
	public static int SCARD_E_UNEXPECTED			=	0x8010001F;

	// Smart card software developer information not accessible
	public static int SCARD_E_ICC_INSTALLATION		=	0x80100020;

	// Smart card vendor information not accessible
	public static int SCARD_E_ICC_CREATEORDER		=	0x80100021;

	// Current smart card does not support the function user demanded
	public static int SCARD_E_UNSUPPORTED_FEATURE		=	0x80100022;

	// The specified directory does not exist
	public static int SCARD_E_DIR_NOT_FOUND			=	0x80100023;

	// The specified file does not exist
	public static int SCARD_E_FILE_NOT_FOUND		=	0x80100024;

	// The specified directory is no longer a valid directory
	public static int SCARD_E_NO_DIR			=	0x80100025;

	// The specified file is no longer a valid file, no file selected
	public static int SCARD_E_NO_FILE			=	0x80100026;

	// The file denies any access
	public static int SCARD_E_NO_ACCESS			=	0x80100027;

	// Card is full, no more data write
	public static int SCARD_E_WRITE_TOO_MANY		=	0x80100028;

	// File pointer error
	public static int SCARD_E_BAD_SEEK			=	0x80100029;
	
	// PIN code error
	public static int SCARD_E_INVALID_CHV			=	0x8010002A;
	
	// An unrecognized error code is returned from smart card service
	public static int SCARD_E_UNKNOWN_RES_MNG		=	0x8010002B;
	
	// The certificate requested does not exist
	public static int SCARD_E_NO_SUCH_CERTIFICATE		=	0x8010002C;
	
	// The certificate requested is not available
	public static int SCARD_E_CERTIFICATE_UNAVAILABLE	=	0x8010002D;
	
	// No card reader found
	public static int SCARD_E_NO_READERS_AVAILABLE		=	0x8010002E;
	
	// Data loss during smart card communication, please try again
	public static int SCARD_E_COMM_DATA_LOST		=	0x8010002F;
	
	// The key file requested does not exist
	public static int SCARD_E_NO_KEY_CONTAINER		=	0x80100030;
	
	// Card reader can not communicate with the card due to software developer information conflict
	public static int SCARD_W_UNSUPPORTED_CARD		=	0x80100065;
	
	// Card does not respond to reset
	public static int SCARD_W_UNRESPONSIVE_CARD		=	0x80100066;
	
	// Card no power
	public static int SCARD_W_UNPOWERED_CARD		=	0x80100067;
	
	// Card is reset, shared information is invalid
	public static int SCARD_W_RESET_CARD			=	0x80100068;
	
	// Card is removed
	public static int SCARD_W_REMOVED_CARD			=	0x80100069;
	
	// Access is denied due to security rules
	public static int SCARD_W_SECURITY_VIOLATION		=	0x8010006A;
	
	// PIN code is not verified, access is denied
	public static int SCARD_W_WRONG_CHV			=	0x8010006B;
	
	// Max. PIN code retry number is reached, access is denied
	public static int SCARD_W_CHV_BLOCKED			=	0x8010006C;
	
	// The last smart card file is reached, no more file available
	public static int SCARD_W_EOF				=	0x8010006D;
	
	// Operation is terminated by user
	public static int SCARD_W_CANCELLED_BY_USER		=	0x8010006E;
	
	// Smart card PIN is not set
	public static int SCARD_W_CARD_NOT_AUTHENTICATED	=	0x8010006F;

	
	// Extended error code  =========================================================
	
	// File already exists
	public static int SCARD_E_FILE_EXISTS			=	0xA0100001;
	
	// Card-resident memory operation error
	public static int SCARD_E_EPROM_ERROR			=	0xA0100002;
	
	// User specified CLA is invalid
	public static int SCARD_E_INVALID_CLA			=	0xA0100003;
	
	// User specified INS is invalid
	public static int SCARD_E_INVALID_INS			=	0xA0100004;
	
	// Virtual machine address out ranged/abnormal 
	public static int SCARD_E_VM_ADDRESS_ERROR		=	0xA0100005;
	
	// 0 division error
	public static int SCARD_E_ZERO_DIVIDE			=	0xA0100006;
	
	// Card is not inserted to the proper place
	public static int SCARD_E_WRONG_POSITION		=	0xA0100007;
	
	// Card is in an unknown status
	public static int SCARD_E_UNKNOWN_STATE			=	0xA0100008;
	
	// Card is not opened
	public static int SCARD_E_CARD_NOT_OPENED		=	0xA0100009;
	
	// Unknown command
	public static int SCARD_E_UNKNOWN_COMMAND		=	0xA010000A;
	
	// Super password reset number is 0
	public static int SCARD_E_ZERO_TRYTIME			=	0xA010000B;
	
	// Too many devices are opened
	public static int SCARD_E_TOO_MANY_DEVICE		=	0xA010000C;
	
	//  Invalid instruction.
	public static int	SCARD_E_INVALID_INSTRUCTION	=	0xA010000D;
	
	// card still have more data to return 
	public static int SCARD_W_RESPONSE			=	0xA01000FF;
	
	// returned data length
	public static int RETURN_LENGTH				=	0xA0100014;
	
	// Error codes exclusive for virtual devices=================================================
	
	// Virtual card file creation failure
	public static int SCARD_E_FILE_CREATE_FAILED		=	0xA0101001;
	
	// Virtual card file open failure
	public static int SCARD_E_FILE_OPEN_FAILED		=	0xA0101002;
	
	public static int SCARD_E_FLOAT_NOT_FOUND         	=	0x0000e00a;
	
	//RSA_DES library not found
	public static int SCARD_E_RSADES_NOT_FOUND        	=	0x0000e00b;
	
	public static int SCARD_E_LIBS_ERROR              	=	0x0000e00c;
	
	public static int SCARD_E_EXTENDFLOAT_NOT_FOUND   	=	0x0000e00d;
	
	//Extended error codes for ROCKEY
	
	//Cannot find ROCKEY
	public static int ROCKEY_K_NOT_FOUND               	=	0xF0100001;
	
	//Search ROCKEY failed	
	public static int ROCKEY_K_QUERY_FAILED            	=	0xF0100002;
	
	//Write ROCKEY failed
	public static int ROCKEY_K_WRITE_FAILED            	=	0xF0100003;
	
	//Read ROCKEY failed
	public static int ROCKEY_K_READ_FAILED             	=	0xF0100004;
	

	public native int DIC_Find();
	public native int DIC_Open(int iDevID,char[] name);
	public native int DIC_Close(int iDevID);
	public native int DIC_GetVersion(char[] ver);
	public native int DIC_Command(int iDevID, int cmd, byte [] cmddata);
	public native int DIC_FindByMgrCode(byte[] pMgrCode);
	public native int DIC_Get(byte [] xdata, int p1, int p2, byte[] buffer);
	public native int DIC_Set(byte[] xdata, int p1, int p2, int p3, byte[] buffer);
	static 
	{
		System.loadLibrary("JavaRockey");
	}
}
