#pragma once
#include "windows.h"


//QueryType define
#define	NR_QUERY_SVRNAME	1	
#define NR_QUERY_HID		2
#define NR_QUERY_CARDINFO	3





//statement of interface function
EXTERN_C{
/*******************************************************************

	SetIniPathName

	Set path of configuration files of net lock on client iniName is file name in which path information is included
	Find will operate according the file

*********************************************************************/
#define R6S_FUNCNAME_SETINIPATH "SetIniPathName"


DWORD WINAPI	SetIniPathName(LPCTSTR iniName);

typedef DWORD (WINAPI* DICSETINI)(LPCTSTR iniName);


/*******************************************************************

	NrGetLastError

	When error on net, use the function to get specific information about errors related to net protocols. 

*********************************************************************/

#define R6S_FUNCNAME_GETNETERR "NrGetLastError"

DWORD WINAPI	NrGetLastError();

typedef DWORD (WINAPI * DICGETERR)();





/*******************************************************************

	DICNet_Find

	Find lock according to management code and return the total number. If Zone,Agent,User1,User2 are all 0, that indicate that return the whole net locks, otherwise, return appointed net lock.

*********************************************************************/
#define R6S_FUNCNAME_FIND "DICNet_Find"

int WINAPI	DICNet_Find(WORD Zone,WORD Agent,WORD User1,WORD User2);

typedef int	(WINAPI *DICFIND)(WORD Zone,WORD Agent,WORD User1,WORD User2);




/******************************************************************

	DICNet_Query

	Query information about lock,iQueryType see define of QueryType above

	Type of pRet is relating to QueryType, see below

	NR6S_QUERY_SVRNAME	serial of 16-bit length
	NR6S_QUERY_HID		hardware ID of 4-bit length
	NR6S_QUERY_CARDINFO	a DICST_CardInfo constructed address
						This command return the same value to GET_CARD_INFO,see instruction of GET_CARD_INFO below

*********************************************************************/

#define R6S_FUNCNAME_QUERY "DICNet_Query"

int	WINAPI	DICNet_Query(int iIndex,int iQueryType,void *pRet);

typedef int (WINAPI* DICQUERY)(int iIndex,int iQueryType,void *pRet);


/******************************************************************

	DICNet_Open

	Open(login)lock, iModule is the module No. to be opened, range from 0 to 255 
	PHandle return a handle, later operations can make the handle a base. 
	

*********************************************************************/

#define R6S_FUNCNAME_OPEN "DICNet_Open"

int WINAPI DICNet_Open(DWORD iIndex,DWORD iModule,DWORD* pHandle);

typedef int (WINAPI* DICOPEN)(DWORD iIndex,DWORD iModule,DWORD* pHandle);



/******************************************************************

	DICNet_Close

	Shut down the lock, dwModule is the handle to be closed
	

*********************************************************************/
#define R6S_FUNCNAME_CLOSE "DICNet_Close"

int WINAPI DICNet_Close(DWORD dwHandle);

typedef int (WINAPI* DICCLOSE)(DWORD dwHandle);


/******************************************************************

	DICNet_Command

	Execute API, dwModule is net handle, cmd is API, buffer is I/O data	

*********************************************************************/
#define R6S_FUNCNAME_CMD "DICNet_Command"

int WINAPI DICNet_Command(DWORD dwHandle,int cmd,void* buf);

typedef int (WINAPI* DICCOMMAND)(DWORD dwHandle,int cmd,void* buf);

}//end extern "C"


/******************************************************************

	instructions to API	

*********************************************************************/

//Public API

#define GET_CARD_INFO				0x02000000
#define GET_HARDWARE_INFO			0x00FF1C00
#define GET_MANAGER_CODE			0x00FF1A00
#define GET_CARD_PRIVILEGE			0x00FF2200
#define GET_REMOTE_INFO				0x00FF1e00
#define SET_REMOTE_INFO				0x00FF1003
#define CHECK_REMOTE_INFO			0x01FF1003
#define GET_CURRENT_DIR				0x00001800
#define SET_CURRENT_DIR				0x0000a400
#define GET_CURRENT_FILE			0x00001801
#define SET_CURRENT_FILE			0x0100a400
#define GET_PARENT_DIR				0x00001802
#define SET_PARENT_DIR				0x0000a402
#define LIST_DIR					0x0000b200
#define	READ_FILE					0x0000b000
#define WRITE_FILE					0x0000d000
#define FORMAT_CARD					0x0000e000
#define CREATE_DIR					0x0000e001
#define CREATE_FILE					0x0100e001
#define REMOVE_DIR					0x0000ee00
#define REMOVE_FILE					0x0000ee01
#define RANDOM						0x00008400
#define RUN							0x03000000

#define CRYPTOTEXT_FILE				0x04000000
#define PLAINTEXT_FILE				0x05000000

#define DESENC						0x00005000
#define DESDEC						0x00005100
#define RSAGENKEY					0x00003300
#define RSAENC						0x00003400
#define RSADEC						0x00003500
#define GETFREESPACE				0X00003000
#define MODULE_GETFILEFLAG			0X00003600
#define MODULE_CRYPTOTEXT_MODFLAG	0x00003700
#define MODULE_PLAINTEXT_MODFLAG	0x00003800
#define MODULE_ENCRYPT_CONTENT		0x00003900

#define SETCOUNTER					0x00005700
#define STEPCOUNTER					0x00005800


#define NET_GETPATH					100
#define NET_LOCK					101
#define NET_UNLOCK					102


//Private API,Not support by DICNet


#define CHECK_SUPER_PASS			0x00FF1002
#define SET_SUPER_PASS				0x00FFF402
#define GET_UPGRADE_REMOTE_PASS		0x00FF2000

#pragma pack(1)

// data is what related to commands

// data structure in data of GET_CARD_INFO command
 typedef struct
{
	char volume[16];
	char atr[15];
} DICST_CardInfo;

// data structure in data of GET_HARDWARE_INFO command 
typedef struct
{
	DWORD FactoryTime;
	DWORD HardSerial;
	DWORD ShipTime;
	DWORD COSVersion;
} DICST_HardInfo;

// data structure in data of GET_MANAGER_CODE command 
typedef struct
{
	WORD Zone;
	WORD Agent;
	WORD User1;
	WORD User2;
} DICST_ManagerCode;

// 1- bit data in data of GET_CARD_PRIVILEGE command
// use bit to show the state of present password
#define DICPR_NOPASS		0
#define	DICPR_SUPERPASS		4
#define	DICPR_REMOTEPASS	8

// data structure in data of GET_REMOTE_INFO, SET_REMOTE_INFO and CHECK_REMOTE_INFO commands
typedef struct
{
	DWORD RemoteTag;
	BYTE RemotePass[8];
} DICST_RemoteInfo;

// data structure in data of GET_UPGRADE_REMOTE_PASS command
typedef struct
{
	DWORD RemoteTag;
	DWORD HardSerial;
	BYTE RemotePass[8];
} DICST_Upgrade_RemotePass;


// data structure in data of GET_CURRENT_DIR, SET_CURRENT_DIR, GET_PARENT_DIR and CREATE_DIR commands
typedef struct
{
	WORD		dirid;			// direction ID
	BYTE		dircla;			// direction class
	BYTE		diratrpri;		// direction property and security level
	WORD		dirsize;		// no use
	char		dirname[16];	// direction name
} DICST_Dir;

// data structure in data of GET_CURRENT_FILE, SET_CURRENT_FILE and CREATE_FILE commands
typedef struct
{
	WORD		fileid;			// file ID
	BYTE		filecla;		// file class
	BYTE		fileatrpri;		// file property and file security level
	WORD		filesize;		// file size
	char		filename[17];	// file name
} DICST_File;

// define of file class
#define FILEATTR_NORMAL			0x00
#define FILEATTR_EXEC			0x10
#define FILEATTR_DIR			0x20
#define FILEATTR_UPIGNORE		0x40
#define FILEATTR_INTERNAL		0x80

// Note: the file form List_DIR command returned may be DICST_Dir or DICST_File Note: LIST_DIR 
// use FILEATTER_DIR to decide which exactly the form is

// the data of READ_FILE command needs data form
typedef struct
{
	WORD		offset;
	WORD		size;
} DICST_Before_Read_Data;

// data structure returned by data of READ_FILE command
typedef struct
{
	WORD		readedsize;
	char		buffer[1];		// unit is readsize
} DICST_After_Read_Data;

// data structure in data of WRITE_FILE command
typedef struct
{
	WORD		offset;
	WORD		size;
	char		buffer[1];		// unit is size
} DICST_Write_Data;

// data structure in data of FORMAT_CARD 
typedef struct
{
	char		volume[16];
	char		atr[15];
	BOOL        isdes;
	BOOL        isfloat;
	BOOL        isExtend;
	BYTE	    bModify;
} DICST_System_Info;

// data structure RUN_DATA needs is :
typedef struct
{
	WORD RunID;
	WORD ParaSize;
	BYTE Para[1];	// unit is ParaSize
} DICST_Before_Run_Data;

// when RUN_DATA return parameter, data structure is:
typedef struct
{
	WORD ResultSize;
	BYTE Result[1]; // unit is ResultSize
} DICST_After_Run_Data;

// data structure in data of SET_SUPER_PASS command
typedef struct
{
	BYTE MaxTryTimes;
	BYTE SuperPass[8];
} DICST_SuperPass_Data;


// data structure in data of CRYPTOTEXT_FILE command
typedef struct
{
	WORD		fileid;			// file ID
	BYTE		filecla;		// file class 
	BYTE		fileatrpri;		// file property and security level 
	WORD		filesize;		// file size 
	char		filename[16];	// file name 
	BYTE		filedata[1];	// file data, unit is file size
} DICST_Before_CryptoFile_Data;

// when CRYPTOTEXT_FILE command return parameter, data structure is:
typedef struct
{
	WORD ResultSize;
	BYTE Result[1]; // unit is ResultSize
} DICST_After_CryptoFile_Data;

// three structures encryption and decryption commands to complete
 typedef struct 
{								//for encryption		//for decryption
	WORD dataLength;			//length of encrypted data	//length of decrypted data
	WORD KeyFileid;				//file ID of DES key file
	BYTE KeyIndex;				//symbol in DES key file for the key in this-time encryption 
								//Notes a DES key file includes many keys for DES use in decryption and encryption
								//use KeyIndex to record every key each time used to decrypt

	char data[1];				//encrypted data			//decrypted data
} DICST_Des_Data;
typedef struct 
{								//for encryption		//for decryption
	WORD	KeyFileid;			//public key file ID	// private key file ID	
	WORD	dataLength;			//length of encrypted data	//length of decrypted data
	char	data[1];			// encrypted data			// decrypted data
} DICST_Rsa_Data;
typedef struct 
{
	WORD pubKeyID;				// public key file ID	
	WORD pubKeySize;			// public key size: 512/1024
	WORD pivKeyID;				//private key ID
 } DICST_Rsa_GenKey;
// three returned structures encryption called 
typedef struct 
{								// for encryption		//for decryption		
	WORD dataLength;			// length of encrypted data returned	// length of decrypted data returned	
char data[1];			//return data after encrpted	//return data after decrypted
} DICST_After_EncDec_Data;

// got module flag structure
typedef struct 
{
	BYTE NumFileID;		//full byte length of executive file ID serial
	WORD fileID[1];		//executive file ID serial that needs to be loaded
}
DICST_Module_GetFLag;
typedef BYTE* FileFlag;	//got value returned after catche module flag 
typedef struct  
{
	BYTE flag;		// file flag
	WORD fileID;	//file ID
}
DICST_PlainText_OneMod;
typedef struct
{
	BYTE dataLen;
	DICST_PlainText_OneMod data[1];
}
DICST_PlainText_ModuleData;

typedef struct 
{
	BYTE numExe;		//number of executive files, max in 3
	BYTE flag;			//flags of next executive files appointed after
	WORD exeFileID[3];	//executive file ID
}
DICST_CryptoText_OneMod;
typedef struct  
{
	BYTE nDataLen;
	DICST_CryptoText_OneMod plaintextModuleData[1];
}
DICST_CryptoText_Encrypt;

typedef struct
{
	BYTE dataLen;
	BYTE data[1];
}
DICST_CryptoText_ModuleData;

#pragma pack()

/******************************************************************

	DIC_Get

	Function that helps users load data from data in DIC_Command 
	enter:
		xdata	object buffer where data to be loaded
p1	module/offset,the highest bit 1 indicates that this is operation of module,otherwise, offset users defined themselves.

p2	mode /size of return,the highest 2 bits indicates mode of return, rest of bits, the size of operation

		buffer	character buffer where data was loaded
	

*********************************************************************/

#define R6S_FUNCNAME_DICGET "DIC_Get"

EXTERN_C int WINAPI DIC_Get(void* xdata, int p1, int p2, char* buffer);

typedef int (WINAPI* PDICGET)(void* xdata, int p1, int p2, char* buffer);



/******************************************************************

	DIC_Set

	function that helps users set data from the data in DIC_Command

input:
xdata	object buffer used for saving
 p1		module/offset,the highest bit 1 indicates that this is operation of module,otherwise,        offset users defined themselves.
 p2	mode /size of return,2 bits in the highest indicates mode of return, rest of bits, the size of operation
 p3		usually the value users want to transfer
 buffer	character buffer where data was to be saved

	

*********************************************************************/

#define R6S_FUNCNAME_DICSET "DIC_Set"

EXTERN_C int WINAPI DIC_Set(void* xdata, int p1, int p2, int p3, char* buffer);

typedef int (WINAPI* PDICSET)(void* xdata, int p1, int p2, int p3, char* buffer);




// ====================================================================
// for p1 parameter in DIC_Get, DIC_Set,we pre-set some operation modes
// set all these operation modes to 1
#define FILL					0x80000000
#define ATR						0x80010000
#define VOLUME					0x80020000
#define FACTORY_TIME			0x80030000
#define HARD_SERIAL				0x80040000
#define SHIP_TIME				0x80050000
#define COS_VERSION				0x80060000
#define ZONE					0x80070000
#define AGENT					0x80080000
#define USER1					0x80090000
#define USER2					0x800A0000
#define DIR_ID					0x800B0000
#define DIR_CLASS				0x800C0000
#define DIR_ATTRIBUTE			0x800D0000
#define DIR_PRIVILEGE			0x800E0000
#define FILE_NO					0x800F0000
#define DIR_NAME				0x80100000
#define FILE_ID					0x80110000
#define FILE_CLASS				0x80120000
#define FILE_ATTRIBUTE			0x80130000
#define FILE_PRIVILEGE			0x80140000
#define FILE_SIZE				0x80150000
#define FILE_NAME				0x80160000
#define WRITE_DATA				0x80170000
#define READ_DATA				0x80180000
#define RUN_DATA				0x80190000
#define RANDOM_SIZE				0x801A0000
#define REMOTE_TAG				0x801B0000
#define REMOTE_PASS				0x801C0000
#define UPGRADE_HARD_SERIAL		0x801D0000
#define UPGRADE_REMOTE_TAG		0x801E0000
#define UPGRADE_REMOTE_PASS		0x801F0000
#define REMOTEPASS_STATUS		0x80200000
#define SUPERPASS_STATUS		0x80210000
#define SUPERPASS_DATA			0x80220000
#define FILE_DATA				0x80230000

#define RELOAD_FLOATLIBS            0x0000e002
#define RELOAD_RSADESLIBS           0x0000e003
#define ISLOADEDFLOATLIBS           0x0000e004
#define ISLOADEDRSADESLIBS          0x0000e005 
#define RELOAD_EXTENDFLOATLIBS      0x0000e006
#define ISLOADEXTENDFLOATLIBS       0x0000e007

//DICST_Des_Data			//Used by DIC_Set
#define DES_KEYFILEID			0x80240000
#define DES_KEYINDEX			0x80250000
#define DES_DATA				0x80260000

//DICST_After_EncDec_Data	//Used by DIC_Get
#define AFTER_ENCDEC_DATA		0x80270000

//DICST_Rsa_Data			//Used by DIC_Set
#define RSA_KEYFILEID			0x80280000
#define RSA_DATA				0x80290000

//DICST_Rsa_GenKey			//Used by Dic_Set
#define RSA_PUBKEYID			0x802A0000
#define RSA_PUBKEYSIZE			0x802B0000
#define RSA_PIVKEYID			0x802C0000


// ====================================================================
// for p2 parameter in DIC_Get, DIC_Set ,2 bits in highest is for indicating ways data transported or returned
#define BY_VALUE				0x00000000
#define BY_DOUBLE				0x40000000
#define BY_ARRAY				0x80000000
#define BY_STRING				0xC0000000

// for DIC_GetData 
// BY_VALUE		data returned is returned by value returned 
// BY_ARRAY	data returned is put in pstr to return
// BY_STRING	if data returned digitalized, it will be put into character serial in pstr to return 
// for  DIC_SetData
// BY_VALUE		input data by p3
// BY_ARRAY	input data by pstr
// BY_STRING	input data by pstr, in which the data is in character serial
// ====================================================================





// error codes
#ifndef SCARD_S_SUCCESS

// successful, no error
#define SCARD_S_SUCCESS 				((DWORD)0x00000000L)

// failed to check internal connection
#define SCARD_F_INTERNAL_ERROR			((DWORD)0x80100001L)

// operation stopped by users
#define SCARD_E_CANCELLED				((DWORD)0x80100002L)

// invalid operational handle
#define SCARD_E_INVALID_HANDLE			((DWORD)0x80100003L)

// invalid parameter (p1, p2)
#define SCARD_E_INVALID_PARAMETER		((DWORD)0x80100004L)

// registered starting information lost or invalid
#define SCARD_E_INVALID_TARGET			((DWORD)0x80100005L)

// not enough memory to run command
#define SCARD_E_NO_MEMORY				((DWORD)0x80100006L)

// the internal waits too long
#define SCARD_F_WAITED_TOO_LONG			((DWORD)0x80100007L)

// buffer users gave too small, not enough for all data returned
#define SCARD_E_INSUFFICIENT_BUFFER		((DWORD)0x80100008L)

// unknown card reader
#define SCARD_E_UNKNOWN_READER			((DWORD)0x80100009L)

// timeout users appointed
#define SCARD_E_TIMEOUT					((DWORD)0x8010000AL)

// other connection using card now
#define SCARD_E_SHARING_VIOLATION		((DWORD)0x8010000BL)

// no card in card reader
#define SCARD_E_NO_SMARTCARD			((DWORD)0x8010000CL)

// unknown type of card
#define SCARD_E_UNKNOWN_CARD			((DWORD)0x8010000DL)

// cannot read the card, quit card operation
#define SCARD_E_CANT_DISPOSE			((DWORD)0x8010000EL)

// present card does not support communication protocols users appointed
#define SCARD_E_PROTO_MISMATCH			((DWORD)0x8010000FL)

// not ready to roger command yet the card
#define SCARD_E_NOT_READY				((DWORD)0x80100010L)

// some varies value are improper
#define SCARD_E_INVALID_VALUE			((DWORD)0x80100011L)

// operation is stopped by system, re-logging or closing computer may cause the problem
#define SCARD_E_SYSTEM_CANCELLED		((DWORD)0x80100012L)

// error on internal communication
#define SCARD_F_COMM_ERROR				((DWORD)0x80100013L)

// unknown error internally
#define SCARD_F_UNKNOWN_ERROR			((DWORD)0x80100014L)

// invalid ATR serial
#define SCARD_E_INVALID_ATR				((DWORD)0x80100015L)

// users try to stop an nonexistent process
#define SCARD_E_NOT_TRANSACTED			((DWORD)0x80100016L)

// cannot use appointed card reader now
#define SCARD_E_READER_UNAVAILABLE		((DWORD)0x80100017L)

// operation stopped, allow server program to quite
#define SCARD_P_SHUTDOWN				((DWORD)0x80100018L)

// buffer of PCI for receiving is too small
#define SCARD_E_PCI_TOO_SMALL			((DWORD)0x80100019L)

// drive of card reader cannot support present card reader
#define SCARD_E_READER_UNSUPPORTED		((DWORD)0x8010001AL)

// drive program of card reader cannot setup own name of itself, already same name on card reader.
#define SCARD_E_DUPLICATE_READER		((DWORD)0x8010001BL)

// card cannot be supported by present card reader
#define SCARD_E_CARD_UNSUPPORTED		((DWORD)0x8010001CL)

// no service started in intelligent card
#define SCARD_E_NO_SERVICE				((DWORD)0x8010001DL)

// ervice has been stopped in intelligent card
#define SCARD_E_SERVICE_STOPPED			((DWORD)0x8010001EL)

// unexpected error in intelligent card
#define SCARD_E_UNEXPECTED				((DWORD)0x8010001FL)

// cannot catch information about supplier who give the intelligent card
#define SCARD_E_ICC_INSTALLATION		((DWORD)0x80100020L)

// cannot catch information about manufacture producing intelligent card
#define SCARD_E_ICC_CREATEORDER			((DWORD)0x80100021L)

// present intelligent card cannot support functions users demand
#define SCARD_E_UNSUPPORTED_FEATURE		((DWORD)0x80100022L)

// no exist the appointed direction
#define SCARD_E_DIR_NOT_FOUND			((DWORD)0x80100023L)

// no exist the appointed file
#define SCARD_E_FILE_NOT_FOUND			((DWORD)0x80100024L)

// appointed direction is not valid direction any more
#define SCARD_E_NO_DIR					((DWORD)0x80100025L)

// appointed file is not valid file any more, no selection on file
#define SCARD_E_NO_FILE					((DWORD)0x80100026L)

// this file is denied to access
#define SCARD_E_NO_ACCESS				((DWORD)0x80100027L)

// room of card is full, no place to write information
#define SCARD_E_WRITE_TOO_MANY			((DWORD)0x80100028L)

// error on setting file point
#define SCARD_E_BAD_SEEK				((DWORD)0x80100029L)

// error on PIN 
#define SCARD_E_INVALID_CHV				((DWORD)0x8010002AL)

// returned from a intelligent card a unrecognized error code
#define SCARD_E_UNKNOWN_RES_MNG			((DWORD)0x8010002BL)

// certification required does not exist
#define SCARD_E_NO_SUCH_CERTIFICATE		((DWORD)0x8010002CL)

// unavailable to get certification required
#define SCARD_E_CERTIFICATE_UNAVAILABLE	((DWORD)0x8010002DL)

// cannot find any card reader
#define SCARD_E_NO_READERS_AVAILABLE	((DWORD)0x8010002EL)

// data lost during intelligent card communicating, try again
#define SCARD_E_COMM_DATA_LOST			((DWORD)0x8010002FL)

// key file required does not exist
#define SCARD_E_NO_KEY_CONTAINER		((DWORD)0x80100030L)

// card reader cannot communicate to card for ART configuration confused
#define SCARD_W_UNSUPPORTED_CARD		((DWORD)0x80100065L)

// no response to reset from the card
#define SCARD_W_UNRESPONSIVE_CARD		((DWORD)0x80100066L)

// no battery the card
#define SCARD_W_UNPOWERED_CARD			((DWORD)0x80100067L)

// card is reset, no shared information
#define SCARD_W_RESET_CARD				((DWORD)0x80100068L)

// card is moved
#define SCARD_W_REMOVED_CARD			((DWORD)0x80100069L)

// request has been denied for the security reason
#define SCARD_W_SECURITY_VIOLATION		((DWORD)0x8010006AL)

// PIN is not verified, request denied
#define SCARD_W_WRONG_CHV				((DWORD)0x8010006BL)

// reach the max time to verify PIN, access denied
#define SCARD_W_CHV_BLOCKED				((DWORD)0x8010006CL)

// reach the last intelligent card file, no more files to access
#define SCARD_W_EOF						((DWORD)0x8010006DL)

// operation stopped by users
#define SCARD_W_CANCELLED_BY_USER		((DWORD)0x8010006EL)

// no configuration to PIN of intelligent card
#define SCARD_W_CARD_NOT_AUTHENTICATED	((DWORD)0x8010006FL)

#endif // SCARD_S_SUCCESS


// extended error codes ===============================================

// files existed
#define SCARD_E_FILE_EXISTS				((DWORD)0xA0100001L)

// error on operation to internal memory in card
#define SCARD_E_EPROM_ERROR				((DWORD)0xA0100002L)

// invalid CLA users gave
#define SCARD_E_INVALID_CLA				((DWORD)0xA0100003L)

// invalid INS users gave
#define SCARD_E_INVALID_INS				((DWORD)0xA0100004L)

// VM address overflowed/abnormal
#define SCARD_E_VM_ADDRESS_ERROR		((DWORD)0xA0100005L)

// error on dividing 0
#define SCARD_E_ZERO_DIVIDE				((DWORD)0xA0100006L)

// incorrect position to insert card
#define SCARD_E_WRONG_POSITION			((DWORD)0xA0100007L)

// unknown state the card is now
#define SCARD_E_UNKNOWN_STATE			((DWORD)0xA0100008L)

// card is not opened yet
#define SCARD_E_CARD_NOT_OPENED			((DWORD)0xA0100009L)

// unknown command
#define SCARD_E_UNKNOWN_COMMAND			((DWORD)0xA010000AL)

// 0 time to reset times of setting super password
#define SCARD_E_ZERO_TRYTIME			((DWORD)0xA010000BL)

// too many devices opened
#define SCARD_E_TOO_MANY_DEVICE			((DWORD)0xA010000CL)

// invalid instruction
#define	SCARD_E_INVALID_INSTRUCTION		((DWORD)0xA010000DL)

// there are data still need to return in the card
#define SCARD_W_RESPONSE				((DWORD)0xA01000FFL)

#define SCARD_E_FLOAT_NOT_FOUND         ((DWORD)0x0000e00aL)
// search but did not found RSA_DES library
#define SCARD_E_RSADES_NOT_FOUND        ((DWORD)0x0000e00bL)

#define SCARD_E_LIBS_ERROR              ((DWORD)0x0000e00cL)

#define SCARD_E_FLOAT_NOT_FOUND         ((DWORD)0x0000e00aL)
// search but did not found RSA_DES library
#define SCARD_E_RSADES_NOT_FOUND        ((DWORD)0x0000e00bL)

#define SCARD_E_LIBS_ERROR              ((DWORD)0x0000e00cL)

#define SCARD_E_EXTENDFLOAT_NOT_FOUND   ((DWORD)0x0000e00dL)

// extended error codes for net encrypted lock ==================================

// error on verifying TOKENINFO entered
#define SCARD_E_TOKEN_CRC				((DWORD)0xA0102001L)

// service changed, ROOTKEY entered is not the same to that in card
#define SCARD_E_ROOTKEY					((DWORD)0xA0102002L)

// used the same TOKENINFO to login
#define SCARD_E_DUPE_LOGIN				((DWORD)0xA0102003L)

// Module No. did not match
#define SCARD_E_MODULE_NUMBER			((DWORD)0xA0102004L)

// Module No. over ranged to the valid 
#define SCARD_E_MODULE_RANGE			((DWORD)0xA0102005L)

// cannot find module data appointed
#define SCARD_E_MODULE_DATA_LOSE		((DWORD)0xA0102006L)

// module data appointed has been deleted
#define SCARD_E_MODULE_DATA_DEL			((DWORD)0xA0102007L)

// error on verifying module data in card
#define SCARD_E_MODULE_DATA_CRC			((DWORD)0xA0102008L)

// got max users
#define SCARD_E_MAX_USER				((DWORD)0xA0102009L)

// out the deadline to login	
#define SCARD_E_OUT_TIME_LIMIT			((DWORD)0xA010200AL)

// login times allowed decreased to 0
#define SCARD_E_NO_MORE_TIMES			((DWORD)0xA010200BL)

// incorrect the verified value of USERINFO
 #define SCARD_E_USERINFO_CRC			((DWORD)0xA010200CL)


//net error codes

#define SCARD_E_NET_BASE				((DWORD)0xA0100100L)	// Base

#define SCARD_E_DLL_EXCEPTION   (SCARD_E_NET_BASE+0x001)//Dic32.dll abnormal
#define SCARD_E_NETWORK	       (SCARD_E_NET_BASE+0x002)//error on net
#define SCARD_E_DLL_NOTFOUND   (SCARD_E_NET_BASE+0x003)// do not find Dic32.dll
#define SCARD_E_PARAMETER	(SCARD_E_NET_BASE+0x004)//error on parameter
#define SCARD_E_NOMODULE	  (SCARD_E_NET_BASE+0x005)// do not find module define file
#define SCARD_E_SVRCACHE				(SCARD_E_NET_BASE+0x009)// error on CacheSize on server
#define SCARD_E_NOHID					(SCARD_E_NET_BASE+0x00A)// DIC device on server damaged or pulled out
#define SCARD_E_NOCOMMAND				(SCARD_E_NET_BASE+0x00B)// server does not support this API
#define SCARD_E_LOGINAGAIN				(SCARD_E_NET_BASE+0x00C)// same module No. was opened at same process twice
#define SCARD_E_NETERROR				(SCARD_E_NET_BASE+0x00D)// error on net transportation, user NrGetLastError() return specific error code
#define	SCARD_E_INVALIDHANDLE			(SCARD_E_NET_BASE+0x00E)// invalid handle, may be it is shut down 
#define	SCARD_E_BADHARDWARE				(SCARD_E_NET_BASE+0x00F)// hardware of net lock damaged
#define	SCARD_E_REFUSE					(SCARD_E_NET_BASE+0x010)// DLL on client modified, service is refused to supply
#define	SCARD_E_BADSERVER				(SCARD_E_NET_BASE+0x011)// service program is modified, no more service will be supplied
#define	SCARD_E_PATHNOTEXAIST			(SCARD_E_NET_BASE+0x012)// userspresent path is deleted or present appointed file is deleted by other users
#define SCARD_E_NODEVICE				(SCARD_E_NET_BASE+0x013)// cannot find lock online
#define SCARD_E_NOMOREDEVICE			(SCARD_E_NET_BASE+0x014)// cannot find more locks online
#define SCARD_E_LOCKED					(SCARD_E_NET_BASE+0x015)// locked by other handle
#define SCARD_E_NEEDLOCK				(SCARD_E_NET_BASE+0x016)// use after locked
#define SCARD_E_CHECKFAILED				(SCARD_E_NET_BASE+0x017)// failed to check data when login 



//net error codes
#define ERR_INIT_SOCK					2001	// error on initializing Winsock
#define ERR_NOSUCHPROTO             2002    // no service made for corresponding protocols
#define ERR_UDPSOCKCREATE			2003    //UDP failed to create socket
#define ERR_UDPSETBROADCAST			2004	//UDP failed to set broadcast
#define ERR_UDPBINDFAILED				2005	//UDP failed to bind 
#define ERR_SVRCALLBACKNULL			2006   //recursive function on server is NULL 
#define ERR_TCPSOCKCREATE				2007    //TCP failed to create socket 
#define ERR_TCPBINDFAILED				2008	//TCP failed to bind 
#define ERR_TCPLISTENFAILED			2009	//TCP failed to listen
#define ERR_NOSUCHSEARCH				2010	//unsupported search
#define ERR_UDPSEND					2012	//UDP failed to send data
#define ERR_UDPTIMEOUT				2013	//UDP waited too long, time is out
#define ERR_UDPRECV					2014	//UDP failed to receive data
#define	ERR_TCPCONNECT				2015	//TCP failed to connect server
#define ERR_TCPSENDTIMEOUT			2016	//TCP  is time out to wait to send
#define	ERR_TCPSEND					2017	//TCP failed to send data
#define ERR_TCPRECVTIMEOUT			2018	//TCP is time out to wait to receive
#define	ERR_TCPRECV					2019	//TCP failed to receive data
#define ERR_IPXSOCKCREATE				2020    //IPX failed to create socket
#define ERR_IPXSETBROADCAST			2021	//IPX failed to set broadcast
#define	ERR_IPXSEND					2022	//IPX failed to send data
#define	ERR_IPXRECV					2023	//IPX failed to receive data
#define ERR_IPXBIND						2024	//IPX failed to bind port
#define ERR_NBSRESET                   2025	//NBS failed to initialize information channel 
#define ERR_NBSADDNAME				2026	//NBS failed to add name
#define ERR_NBSSEND					2027	//NBS failed to send
#define ERR_NBSRECV					2028	//NBS reaccept failure


/*************************************************Below are the APIs newly added for Rockey6Smart Plus***********************************************/

#ifndef __cplusplus
extern "C" {
#endif

#define COMMAND_DATA_SIZE 2048
#define NOT_SUPPORT_SIZE_DURING_GENERATE_RSA_KEY 0x10000001
#define NO_PASSED 0															//password incorrect by verification
#define SUPER_PASSWORD_PASSED 4													//super password correct by verification
#define REMOTE_PASSWORD_PASSED 8												//remote update password correct by verification
#define SUPER_REMOTE_PASSWORD_PASSED 12											//both super password and remote update password correct by                                                                                                                         //verification

	//	BYTE gDesKey[128];
	//	BYTE gRsaPubKey[128];


	//Function:				sequential table reverse
	//internal use
	void reverseByte(BYTE* pBuf,DWORD len);
	void reverseDword(DWORD* pBuf,DWORD len);

	//the parameter hic of the following functions is the handle of the dongle

	//Function:				get volume label and developer info
	//strVolume:			return the volume label of the dongle
	//strManufactureInfo:	return the developer info in the dongle
	//These 2 parameters can be changed by developers. But end users cannot do that.
	EXTERN_C int WINAPI DICNet_GetCardInfo(int hic, char strVolume[17], char strManufactureInfo[16]);

	//Function:				get production date and time, serial number, time of sale, and COS version number
	//pdwProduceTime:		return the production date and time of the dongle
	//pdwSerial:			return the serial number of the dongle
	//pdwSalesTime:			return the time of sale of the dongle
	//pdwCOSVersion:		return the version number of the COS in the dongle
	//These 4 parameters are specified by the manufacturer before shipment, and cannot be changed later.
	EXTERN_C int WINAPI DICNet_GetHardwareInfo(int hic, 
		DWORD *pdwProducedTime, 
		DWORD *pdwSerial, 
		DWORD *pdwSalesTime, 
		DWORD *pdwCOSVersion);

	//Function:					get regional code, agent code, and 2 user codes
	//pwZoneCode:				return regional code
	//pwAgentCode:				return agent code
	//pwUser1Code:				return code of user 1
	//pwUser2Code:				return code of user 2
	EXTERN_C int WINAPI DICNet_GetManagerCode(int hic, 
		WORD *pwZoneCode, 
		WORD *pwAgentCode, 
		WORD *pwUser1Code, 
		WORD *pwUser2Code);

	//Function:					get password verification status, which is returned by enumeration variable penumState; for the meaning of each return                                                         //value, see below:
	//	NO_PASSED = 0,									//password incorrect by verification
	//	SUPER_PASSWORD_PASSED = 4,						//super password correct by verification
	//	REMOTE_PASSWORD_PASSED = 8,						//remote update password correct by verification
	//	SUPER_REMOTE_PASSWORD_PASSED = 12				//both super password and remote update password correct by verification
	EXTERN_C int WINAPI DICNet_GetPasswordVerifyState(int hic, int *piState);

	//Function:					get remote update flag and password
	//pdwFlag:					return remote update flag
	//abyPassword:				return remote update password
	EXTERN_C int WINAPI DICNet_GetRemoteInfo(int hic, DWORD *pdwFlag, BYTE abyPassword[8]);

	//Function:					configure remote update flag and password
	//dwFlag:					configure remote update flag
	//abyPassword:				configure remote update password
	EXTERN_C int WINAPI DICNet_SetRemoteInfo(int hic, DWORD dwFlag, const BYTE abyPassword[8]);

	//Function:					verify remote update flag and password
	//dwFlag:					the remote update flag to be verified
	//dwPassword:				the remote update password to be verified
	EXTERN_C int WINAPI DICNet_CheckRemoteInfo(int hic, DWORD dwFlag, const BYTE byPassword[8]);

	//Below are some operations for files and directories.

	//The class of a file or directory is a number ranging from 0x00 to 0xff.

	
	//FILEATTR_NORMAL			generic data file
	//FILEATTR_EXEC				means executable
	//FILEATTR_DIR				means directory
	//FILEATTR_UPIGNORE			means the program will not be executed if current security level is higher than the level of the executable itself
	//FILEATTR_INTERNAL			means a file used by internal applications; cannot be operated externally
                                              //if an executable has internal attributes configured, the supper password is required for displaying it when listing directory

	//The security level of a file or directory is a number ranging from 0x00 to 0x0f.

	//Function:					get current directory ID, class, property, security level, and name
	//pwDirID:					return current directory ID
	//pbyDirType:				return current directory class
	//pbyDirAttribute:			return current directory property
	//pbyDirSecurity:			return current directory security level
	//strDirName:				return current directory name
	EXTERN_C int WINAPI DICNet_GetCurrentDir(int hic, 
		WORD *pwDirID, 
		BYTE *pbyDirType, 
		BYTE *pbyDirAttribute, 
		BYTE *pbyDirSecurity, 
		char strDirName[17]);

	//Function:					set current directory to a directory identified by wDirID
	//wDirID:					directory ID
	//strDirName:				directory ID
	//Remarks:					can configure current directory by directory ID or name; pass one of them
	//							another one can be set to 0 or NULL; if both of them are passed, they must denote the same directory
	EXTERN_C int WINAPI DICNet_SetCurrentDir(int hic, 
		WORD wDirID,
		char strDirName[17]);

	//Function:					get current file ID, class, property, security level, and name
	//pwFileID:					return current file ID
	//pbyFileType:				return current file class
	//pbyFileAttribute:			return current file property
	//pbyFileSecurity:			return current file security level
	//strFileName:				return current file name
	EXTERN_C int WINAPI DICNet_GetCurrentFile(int hic, 
		WORD *pwFileID, 
		BYTE *pbyFileType, 
		BYTE *pbyFileAttribute, 
		BYTE *pbyFileSecurity, 
		char strFileName[18]);

	//Function:					set current file to a file identified by wFileID
	//wFileID:					file ID
	//strFileName:				filename
	//Remarks:					can be configured by file ID or name; pass one of them
	//							another one can be set to 0 or NULL; if both of them are passes, they must denote the same file
	EXTERN_C int WINAPI DICNet_SetCurrentFile(int hic, 
		WORD wFileID,
		char strFileName[18]);

	//Function:					get the ID, class, property, security level, and name of the upper-level directory
	//pwDirID:					return ID of the upper-level directory
	//pbyDirType:				return class of the upper-level directory
	//pbyDirAttribute:			return property of the upper-level directory
	//pbyDirSecurity:			return security level of the upper-level directory
	//strDirName:				return name of the upper-level directory
	EXTERN_C int WINAPI DICNet_GetParentDir(int hic, 
		WORD *pwDirID, 
		BYTE *pbyDirType, 
		BYTE *pbyDirAttribute, 
		BYTE *pbyDirSecurity, 
		char strDirName[17]);

	//Function:					return to the upper-level directory
	EXTERN_C int WINAPI DICNet_SetParentDir(int hic);

	//Function:					list all directories and files under current directory; used with DICNet_FindNextFileOrDir
	//piPosition:				if -1 returned, no file/directory exists under current directory; other values mean some directories/files have not been listed yet
	//							can get remaining directories/files by calling DICNet_FindNextFileOrDir function
	//pwID:						return ID of the first directory or file under current directory
	//pbyType:					return class of the first directory or file under current directory
	//pbyDirAttribute:			return property of the first directory or file under current directory
	//pbyDirSecurity:			return security level of the first directory or file under current directory
	//strName:					return name of the first directory or file under current directory
	EXTERN_C int WINAPI DICNet_FindFirstFileOrDir(int hic, 
		int *piPosition, 
		WORD *pwID, 
		BYTE *pbyType, 
		BYTE *pbyAttribute, 
		BYTE *pbySecurity, 
		char strName[18]);

	//Function:					list all directories and files under current directory; used with DICNet_FindFirstFileOrDir
	//piPosition:				if -1 returned, all directories/files under current directory have been listed; other values mean some directories/files have not                                                //been listed yet
	//							can get remaining directories/files by calling DICNet_FindNextFileOrDir function
	//pwID:						return ID of the next directory/file after piPosition under current directory
	//pbyType:					return class of the next directory/file after piPosition under current directory
	//pbyDirAttribute:			return property of the next directory/file after piPosition under current directory
	//pbyDirSecurity:			return security level of the next directory/file after piPosition under current directory
	//strName:					return name of the next directory/file after piPosition under current directory
	EXTERN_C int WINAPI DICNet_FindNextFileOrDir(	int hic, 
		int *piPosition, 
		WORD *pwID, 
		BYTE *pbyType, 
		BYTE *pbyAttribute, 
		BYTE *pbySecurity, 
		char strName[18]);

	//Note: When reading/writing to a file, the file must be set to be the current file first. This can be done by DICNet_SetCurrentFile.
	//DICNet_CreateFile will set the created file to be the current file automatically.

	//Function:					read current file
	//wOffset:					offset of current file
	//pwRead:					pass the size of the data to be read; return the actual size of the data that has been read
	//pBuf:						buffer for receiving data
	EXTERN_C int WINAPI DICNet_ReadFile(int hic, WORD wOffset, WORD *pwRead, char *pBuf);

	//Function:					write to current file
	//wOffset:					offset of current file
	//wWrite:					size of data to be written
	//pBuf:						buffer for storing the written data
	EXTERN_C int WINAPI DICNet_WriteFile(int hic, WORD wOffset, WORD wWrite, const char *pBuf);

	////Function:					formatting
	////strVolume:				volume label
	////strManufactureInfo:		developer info
	////Remark:					close and open to make the new format effective
	//EXTERN_C int WINAPI DICNet_FormatCard(int hic, char strVolume[17], char strManufactureInfo[16]);

	//Function:					create a directory
	//wDirID:					ID of the directory to be created
	//byDirType:				class of the directory to be created
	//byDirAttribute:			property of the directory to be created
	//byDirSecurity:			security level of the directory to be created
	//strDirName:				name of the directory to be created
	EXTERN_C int WINAPI DICNet_CreateDir(int hic, 
		WORD wDirID, 
		BYTE byDirType, 
		BYTE byDirAttribute, 
		BYTE byDirSecurity, 
		const char strDirName[17]);

	//Function:					create a file
	//wFileID:					ID of the file to be created
	//byFileType:				class of the file to be created
	//byFileAttribute:			property of the file to be created
	//byFileSecurity:			security level of the file to be created
	//strFileName:				name of the file to be created
	EXTERN_C int WINAPI DICNet_CreateFile(int hic, 
		WORD wFileID, 
		BYTE byFileType, 
		BYTE byFileAttribute, 
		WORD wFileSize, 
		BYTE byFileSecurity, 
		const char strFileName[18]);

	//Function:					delete current directory
	EXTERN_C int WINAPI DICNet_DeleteDir(int hic);

	//Function:					delete current file
	EXTERN_C int WINAPI DICNet_DeleteFile(int hic);

	//Function:					get a random number
	//byRandomLength:			length of the random number; the maximum is 16
	//abyRandom:				array for storing the random number
	EXTERN_C int WINAPI DICNet_Random(int hic, BYTE byRandomLength, BYTE abyRandom[16]);

	//Function:					run an executable file
	//wRunFileNameID:			file ID represented by the filename of executable file; not the file ID of the executable file
	//							the filename of executable file is a WORD value represented by a string, such as "6AB3" and "032B"
	//							for example, if the filename of the executable file is "6AB3", 0x6AB3 should be passed
	//wParamSize:				pass startup parameter size
	//cpcParam:					pass startup parameter
	//							the startup parameter is a string of various input parameters; for example, if the input parameters include an 8-
        //                                                      byte double value and a 2-byte WORD value, the first 8 bytes of cpcParam is the double value and the following 2
	//							bytes are the WORD value; the size of wParamSize is 10
	//pwRetDataLength:			size of returned data after execution
	//pcRetData:				returned data after executaion
	//							this parameter is a string of the returned data after executaion; for example, if the returned data includes a 4-
        //                                                      byte float value and a 4-byte DWORD value, the 1st 4 bytes of the parameter are the float value,
	//							and the following 4 bytes are the DWORD value; the size of *pwRetDataLength is 8
	EXTERN_C int WINAPI DICNet_Run(int hic, WORD wRunFileNameID, WORD wParamSize, const char *cpcParam, WORD *pwRetDataLength, char *pcRetData);

	////Function:					generate a cipher-text file using TEA algorithm, which is stored in pcEncData; a temporary file is required for this
        ////                                            algorithm; the temporary file can be deleted by calling DIC_DeleteFile after execution of this function
	////wFileID:					ID of temporary file
	////byFileType:				class of temporary file
	////byFileAttribute:			property of temporary file
	////pwFileSize:				pass size of cpcFileData; return size of pcEncData
	////byFileSecurity:			security level of temporary file
	////strFileName:				name of temporary file
	////cpcFileData:				pointer to file data to be encrypted
	////pcEncData:				pointer to file data that has been encrypted; the data pointed (size:*pwFileSize) can be sent to destination via network media
	////							passed as the 2nd parameter of DICNet_TeaEncryptedFile2PlainFile function at the destination; remote update can be
        ////                                                    completed using these 2 functions
	//int WINAPI DICNet_EncryptFileUseTea(int hic, 
	//	WORD wFileID, 
	//	BYTE byFileType, 
	//	BYTE byFileAttribute, 
	//	WORD *pwFileSize, 
	//	BYTE byFileSecurity, 
	//	const char strFileName[18], 
	//	const char *cpcFileData,
	//	char *pcEncData);

	////Function:					for remote update with DICNet_EncryptFileUseTea function; write the encrypted data returned by the parameter pcEncData of         ////                                            DICNet_EncryptFileUseTea function to the dongle as a plain-text file; the ID is the ID of the temporary file as
	////							defined in DICNet_EncryptFileUseTea function
	////cmddata:					encrypted data returned by the parameter pcEncData of DICNet_EncryptFileUseTea function
	//int WINAPI DICNet_TeaEncryptedFile2PlainFile(int hic, char *cmddata);

	////Function:					verify super password
	////abySuperPW:				super password; cannot be an all-zero string; or, it will be locked
	//EXTERN_C int WINAPI DICNet_CheckSuperPassword(int hic, BYTE abySuperPW[8]);

	////Function:					set super password
	////byTryTimesCeiling:		the maximum number of retries for verification of super password
	////abySuperPW:				super password; cannot be an all-zero string; or, it will be locked
	//EXTERN_C int WINAPI DICNet_SetSuperPassword(int hic, BYTE byTryTimesCeiling, BYTE abySuperPW[8]);

	////Function:					get remote update password
	////dwRemoteFlag:				flag of this remote update
	////dwHardSerial:				hardware serial number of this remote update
	////abyRemotePW:				enter the password of this remote update; return the password of next remote update
	//EXTERN_C int WINAPI DICNet_GetRemoteUpgradePassword(int hic, DWORD dwRemoteFlag, DWORD dwHardSerial, BYTE abyRemotePW[8]);

	//						for DES algorithm, the length of the encrypted/decrypted data must be an integer number of times of  key length (8 bytes)

	//Function:					encrypt a set of data using DES algorithm
	//wKeyFileID:				ID of key file
	//byKeyIndex:				key index in key file; indicates which key is used
	//wDataLength:				length of data to be encrypted
	//cpcDataSrc:				data to be encrypted
	//pcDataEnc:				data that has been encrypted
	EXTERN_C int WINAPI DICNet_DesEncrypt(int hic, WORD wKeyFileID, BYTE byKeyIndex, WORD wDataLength, const char *cpcDataSrc, char *pcDataEnc);

	//Function:					decrypt using DES algorithm
	//wKeyFileID:				ID of key file
	//byKeyIndex:				key index in key file; see description of DICNet_GenerateDesKeyFile function
	//wDataLength:				length of data to be decrypted
	//cpcDataSrc:				data to be decrypted
	//pcDataDec:				data that has been decrypted
	EXTERN_C int WINAPI DICNet_DesDecrypt(int hic, WORD wKeyFileID, BYTE byKeyIndex, WORD wDataLength, const char *cpcDataSrc, char *pcDataDec);

	//Function:					generate a DES key file; length of key can be 8 or 16 bytes; for 16-byte keys, 3DES algorithm will be used automatically
        //                                              for encryption/decryption
	//wKeyFileID:				ID of the key file that is generated
	//wKeyDataLength:			length of key data
	//pcKeyData:				key data
	//						the key data has a form like the following: "\x03\x10\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F\x10\
	//\x01\x08\x01\x02\x03\x04\x05\x06\x07\x08"	where, the first \x03 means the following is a key indexed as 3; the second \x10 (hex) means the length of the key is 16
	//							bytes; the following 16 bytes are the key indexed as 3; the following 19th byte \x01 means the following is a key         //                                                      indexed as 1; \x08 means the length of the key is 8 bytes; the following 8 bytes is the key indexed as 1;
	//							users can write keys to the key file by calling DICNet_WriteFile function
	//							for example, to generate a DES key file containing the above key data and then write a key indexed as 2 which is 8
	//							bytes long, the code can be written as follows:
	//							DICNet_GenerateDesKeyFile(hic, 0x1003, 28, "\x03\x10\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0A\x0B\x0C\x0D\x0E\x0F\x10\
	//\x01\x08\x01\x02\x03\x04\x05\x06\x07\x08");
	//							DICNet_SetCurrentFile(hic, 0x1003);
	//							DICNet_WriteFile(hic, 28, 10, "\x02\x08\x01\x02\x03\x04\x05\x06\x07\x08");
	EXTERN_C int WINAPI DICNet_GenerateDesKeyFile(int hic, WORD wKeyFileID, WORD wKeyDataLength, char *pcKeyData);

	////Function:					generate RSA public/private key file using specified public/private key ID and size of public key; currently, only 512-bit
        ////                                            and 1024-bit are supported for key length
	////wPublicKeyFileID:			ID of public key file
	////wPublicKeySize:			size of public key
	////wPrivateKeyFileID:		ID of private key file
	//EXTERN_C int WINAPI DICNet_GenerateRsaKey(int hic, WORD wPublicKeyFileID, WORD wPublicKeySize, WORD wPrivateKeyFileID);

	//							for RSA algorithm, the following must be known: decrypt a set of plain data with a private key and then encrypt it
	//							with a public keyencrypt the plain data with a public key and then decrypt it with a private keyplain data
        //                                                      length of the data to be encrypted/decrypted must be an integer number of times of key len. 512/8=64 or 1024/8=128

	//Function:					encrypt a set of data using RSA algorithm
	//wPublicKeyFileID:			ID of public key file
	//wDataLength:				length of data to be encrypted
	//cpcDataSrc:				data to be encrypted
	//pcDataEnc:				data that has been encrypted
	//bIsDataSrcFromOpenssl:	if the data to be encrypted is from the data that has been dealed with by Openssl or not (if so, the byte sequence must be reversed before
        //                              the dongle)
	EXTERN_C int WINAPI DICNet_RsaEncrypt(int hic, WORD wPublicKeyFileID, WORD wDataLength, const char *cpcDataSrc, char *pcDataEnc, BOOL bIsDataSrcFromOpenssl);


	//Function:					decrypt a set of data using RSA algorithm
	//wPrivateKeyFileID:		ID of private key file
	//wDataLength:				length of data to be decrypted
	//cpcDataSrc:				data to be decrypted
	//pcDataDec:				data that has been decrypted
	//bIsDataSrcFromOpenssl:	if the decrypted data is from the data that has been dealed with by Openssl (if so, the byte sequence must be reversed before the dongle)
	EXTERN_C int WINAPI DICNet_RsaDecrypt(int hic, WORD wPrivateKeyFileID, WORD wDataLength, const char *cpcDataSrc, char *pcDataDec, BOOL bIsDataSrcFromOpenssl);

	//Function:					get size of remaining dongle space
	//pdwFreeSpace:				return the size of the remaining dongle space
	EXTERN_C int WINAPI DICNet_GetFreeSpace(int hic, DWORD *pdwFreeSpace);

	////Function:					set the initial value of counter
	////dwInit:					the initial value of the counter
	//EXTERN_C int WINAPI DICNet_SetCounter(int hic, DWORD dwInit);

	//Function:					decrease the value of the counter by 1
	EXTERN_C int WINAPI DICNet_DecreaseCounter(int hic);

	//Function:					generate a public key file with Openssl
	//wPublicKeyFileID			ID of public key file
	//wPublicKeySize			size of public key
	//cpbyPublicKeyData			public key data (typically, it is "n" in the RSA structure resulted by BN_bn2bin function)
	EXTERN_C int WINAPI DICNet_GenerateRsaPublicKeyFile(int hic, WORD wPublicKeyFileID, WORD wPublicKeySize/*512/1024/2048*/, const BYTE *cpbyPublicKeyData);

	//Function:					generate a private key file with Openssl
	//wPrivateKeyFileID			ID of private key file
	//wPrivateKeySize			size of private key
	//cpbyPrivateKeyDataD		private key data D (typically, it is "d" in the RSA structure resulted by BN_bn2bin function)
	//cpbyPrivateKeyDataN		private key data N (typically, it is n in the RSA structure resulted by BN_bn2bin function)
	EXTERN_C int WINAPI DICNet_GenerateRsaPrivateKeyFile(int hic, WORD wPrivateKeyFileID, WORD wPrivateKeySize/*512/1024/2048*/, const BYTE *cpbyPrivateKeyDataD, const BYTE *cpbyPrivateKeyDataN);

	//Function:					lock the network dongle
	extern "C" int WINAPI DICNet_Lock(int hic);

	//Function:					unlock the network dongle
	extern "C" int WINAPI DICNet_UnLock(int hic);

	//Function:					get current path
	//awPath:					save current path
	extern "C" int WINAPI DICNet_GetPath(int hic, WORD awPath[256]);

#ifndef __cplusplus
};
#endif


