// ==========================================================================
// object: sample of net lock
// instruction:
// dynamically load Nr6Cli.dll (dynamic link library)to complete functions
// =========================================================================

unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls ;

type
    TForm1 = class(TForm)
    List: TListBox;
    Button1: TButton;

    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

var
    Form1: TForm1;
    hDic32: THandle;

implementation

uses head;     //include definitions of interface and constants

{$R *.dfm}
function InitFunction():Integer;
begin
    hDic32:=Loadlibrary('Nr6Cli.dll');
    if hDic32 = 0 then
    begin
        Form1.List.Items.Add('cannot find Nr6Cli.dll');
        result:=-1;
        exit;
    end;

    DIC_Find := GetProcAddress(hDic32, 'DICNet_Find');
    DIC_Query := GetProcAddress(hDic32, 'DICNet_Query');
    DIC_Open := GetProcAddress(hDic32, 'DICNet_Open');
    DIC_Command := GetProcAddress(hDic32, 'DICNet_Command');
    DIC_Get  := GetProcAddress(hDic32, 'DIC_Get');
    DIC_Set  := GetProcAddress(hDic32, 'DIC_Set');
    DIC_Close := GetProcAddress(hDic32, 'DICNet_Close');
    if((Integer(@DIC_Find)=0) or (Integer(@DIC_Query)=0) or (Integer(@DIC_Open)=0) or
        (Integer(@DIC_Command)=0) or (Integer(@DIC_Get)=0) or (Integer(@DIC_Set)=0) or
        (Integer(@DIC_Close)=0))  then
    begin
        Form1.List.Items.Add('Init function Err!');
        result:=-1;
        exit;
    end;
    result:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var

zone_,agent_,user1_,user2_:word;
str,s_temp,s_serverName:string;
errcode:Integer;    // error code
num,index,hid:Integer;		// numbers of found card reader
hic:Integer;        // handle of device
i:Integer;
buf,buffer,cmddata:array [0..256]of Char;

begin
    List.Items.Clear();
	zone_:=$8056; agent_:=$8000; user1_:=$ffff; user2_:=$ffff;// set according to management code of real net lock
	num := DIC_Find(zone_,agent_,user1_,user2_);
	if(num<1) then
    begin
		List.Items.Add('can not find any rockey!');
		exit;
	end;

	index:=0;//(can be 0 to num-1)

	//2.query
	errcode:=DIC_Query(0,NR_QUERY_SVRNAME,buf);
	FmtStr(str,'Server Name: %s', [buf]);
    List.Items.Add(str);

	errcode:=DIC_Query(0,NR_QUERY_HID,buf);
	hid:=DIC_Get(buf,0,BY_VALUE or 4,nil);
	FmtStr(str,'Hard Serial: %x', [hid]);
    List.Items.Add(str);

	errcode:=DIC_Query(0,NR_QUERY_CARDINFO,buf);
	DIC_Get(buf, ATR, BY_ARRAY,buffer);	// load ATR
    FmtStr(str,'ATR: %s', [buffer]);
	List.Items.Add(str);

    DIC_Get(buf, VOLUME, BY_ARRAY,buffer);	// load information about volume label    FmtStr(str,'Volumn: %s', [buffer]);
	List.Items.Add(str);

	//3.open
	errcode:=DIC_Open(index,0,@hic);//open No. 0 module,
	if(errcode <> 0) then
    begin
		List.Items.Add('open failed');
		exit;
	end;

	//4.executting command
	//take creating file and writing file examples, commands else are all the same ( the same at lock of single version)
  //but those commands required password
	DIC_Set(cmddata, FILL, 256, 0, nil);	// delete all
	DIC_Set(cmddata, FILE_ID, BY_VALUE, $2008, nil);	// files ID, hex:2008
	DIC_Set(cmddata, FILE_CLASS, BY_VALUE, 255, nil);	// files category
	DIC_Set(cmddata, FILE_ATTRIBUTE, BY_VALUE, FILEATTR_NORMAL, nil);	// files property
	DIC_Set(cmddata, FILE_SIZE, BY_VALUE, 20, nil);	// file size
	DIC_Set(cmddata, FILE_NAME, BY_ARRAY, 0, 'File1');	// long file name
	errcode := DIC_Command(hic, CREATE_FILE, cmddata);

	// i. Write 20-bit information into this file
	//    Note: after file created, it will be set automatically to present file, donot need to set again
	DIC_Set(cmddata, WRITE_DATA, 20, 0,'abcdefghijklmnopqrst');
	errcode := DIC_Command(hic, WRITE_FILE, cmddata);

	if(errcode = 0) then
		s_temp:='writting file success'
	else
		s_temp:='writting file error';

	List.Items.Add(s_temp);
	
	// 5. close
	errcode := DIC_Close(hic);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    if(InitFunction()<>0) then
        exit;
    Button1Click(nil);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Freelibrary(hDic32);
end;

END.
