//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdio.h"
#include "Rockey.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        Memo1->Clear();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{

        CROCKEY        Ry;
        char            chMsg[256];
        int             iRet,i,iDevID;

        //----------------------------------------------------------------------
        //Demo0: Init Rockey Class.
        //----------------------------------------------------------------------

        Memo1->Clear();
        if(!Ry.m_bInitOK)
        {
            //Init failed. dll not found.
            Memo1->Lines->Add("Error: Dic32u.dll not found.Please ensure it's in current directory.");
            goto ENDFUNC;
        }
        else
        {
            //Succeeded. Show current dll version.
            char chDllVer[32];

            Ry.GetVer(chDllVer);
            sprintf(chMsg,"Dll bounded. ver %s.",chDllVer);
            Memo1->Lines->Add(chMsg);
        }

        //----------------------------------------------------------------------
        //Demo1:Find.
        //Get maximum device numbers.
        //----------------------------------------------------------------------

        int iMaxDevs;

        iMaxDevs=Ry.Find();
        if(!CheckResult(iMaxDevs,"DIC_Find")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Find: found %d devices.\r\n",iMaxDevs);
        Memo1->Lines->Add(chMsg);

        //----------------------------------------------------------------------
        //Demo2:Open
    	//Open the first device.
        //----------------------------------------------------------------------



	    sprintf(chMsg,"******** Opening device ...");
        Memo1->Lines->Add(chMsg);

        for(i=0; i<iMaxDevs; i++)
        {
            iRet=Ry.Open(i,NULL);      //No need to know the name of Card.
            if(iRet>=0) break;          //break if succeess, only open the first.
        }

        if(i==iMaxDevs)
        {
            Memo1->Lines->Add("Error: Please insert a Rockey to retry.");
            goto ENDFUNC;
        }
        else
        {
            sprintf(chMsg,"Device %d opened.\r\n",i);
            Memo1->Lines->Add(chMsg);
        }

        iDevID=i;

        //----------------------------------------------------------------------
        //Demo3:Check super password.
        //----------------------------------------------------------------------

        BYTE bySuperPassword[8];

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;

        Memo1->Lines->Add("******** Check super password FF FF FF FF FF FF FF FF");
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);

	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo4:FormatCard.
        //----------------------------------------------------------------------

        DICST_System_Info FormatInfo;

        strncpy(FormatInfo.atr,"ATR_Test",15);
        strncpy(FormatInfo.volume,"Volumn_Test",16);

	    Memo1->Lines->Add("******** Format card, Volume:Volumn_Test, ATR:ATR_Test");

	    iRet=Ry.Command(iDevID,FORMAT_CARD,&FormatInfo);
	    if(!CheckResult(iRet,"DIC_CMD:FORMAT_CARD")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo5, Close and reopen to return normal privilege.
        //
        //----------------------------------------------------------------------

	    Memo1->Lines->Add("******** Return to normal privilege");

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

	    Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo6: Set Remote password. ONLY CAN be used after card format.
        //----------------------------------------------------------------------

        DICST_RemoteInfo initRmtInfo;

        initRmtInfo.RemoteTag=0x00001001;
        for(i=0; i<8; i++) initRmtInfo.RemotePass[i]=(BYTE)i;


        Memo1->Lines->Add("******** Set Remote information.(Tag=0x1001,PW= 00 01 02 03 04 05 06 07)");

        iRet=Ry.Command(iDevID,SET_REMOTE_INFO,&initRmtInfo);
	    if(!CheckResult(iRet,"DIC_CMD:SET_REMOTE_INFO")) goto ENDFUNC;

    	Memo1->Lines->Add("[OK]\r\n");


        //----------------------------------------------------------------------
        //Demo7:Get Romote information.
        //----------------------------------------------------------------------

        DICST_RemoteInfo    curRmtInfo;

        Memo1->Lines->Add("******** Get remote information");

        iRet=Ry.Command(iDevID,GET_REMOTE_INFO,&curRmtInfo);
	    if(!CheckResult(iRet,"DIC_CMD:GET_REMOTE_INFO")) goto ENDFUNC;

	    sprintf(chMsg,"RemoteTag is %08X, Remote password is ",curRmtInfo.RemoteTag);
	    for(i=0; i<8; i++)
        {
            char chTemp[8];

            sprintf(chTemp,"%02X ",curRmtInfo.RemotePass[i]);
            strcat(chMsg,chTemp);
        }
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo8: Get next remote upgrade password.
        //----------------------------------------------------------------------


        //first, we need hardware ID.

        DICST_HardInfo  hardInfo;

    	iRet=Ry.Command(iDevID,GET_HARDWARE_INFO,&hardInfo);
	    if(!CheckResult(iRet,"DIC_CMD:GET_HARDWARE_INFO")) goto ENDFUNC;

        //Then , we need check super password.

        for(i=0; i<8; i++) bySuperPassword[i]=0xFF;
	    iRet=Ry.Command(iDevID,CHECK_SUPER_PASS,bySuperPassword);
	    if(iRet<0)
	    {
		    Memo1->Lines->Add("Error: super password is not FF FF FF FF FF FF FF FF,please modify it.\r\n");
		    goto ENDFUNC;
	    }

        //OK, we can get next remote upgrade password now.


        BYTE byCmdBuf[256];

        DICST_Upgrade_RemotePass* pnewUpgPW;

        pnewUpgPW=(DICST_Upgrade_RemotePass*)byCmdBuf;

        Memo1->Lines->Add("******** Get upgrade remote password");

        pnewUpgPW->RemoteTag=curRmtInfo.RemoteTag+1;
        pnewUpgPW->HardSerial=hardInfo.HardSerial;
        memcpy(pnewUpgPW->RemotePass,curRmtInfo.RemotePass,8);

        iRet=Ry.Command(iDevID,GET_UPGRADE_REMOTE_PASS,byCmdBuf);
	    if(!CheckResult(iRet,"DIC_CMD:GET_UPGRADE_REMOTE_PASS")) goto ENDFUNC;

    	sprintf(chMsg,"New remote password is: ");
        for(i=0; i<8; i++)
        {
            char chTemp[8];

            sprintf(chTemp,"%02X ",byCmdBuf[i]);
            strcat(chMsg,chTemp);
        }
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");


        //Return to normal privilege.

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

	    iRet=Ry.Open(iDevID,NULL);
	    if(!CheckResult(iRet,"DIC_Open")) goto ENDFUNC;

        //----------------------------------------------------------------------
        //Demo9: Check new remote upgrade password.
        //----------------------------------------------------------------------

        DICST_RemoteInfo	checkRmtInfo;

        Memo1->Lines->Add("******** Check upgrade remote information");

        checkRmtInfo.RemoteTag=curRmtInfo.RemoteTag+1;
        memcpy(checkRmtInfo.RemotePass,byCmdBuf,8);


        iRet=Ry.Command(iDevID,CHECK_REMOTE_INFO,&checkRmtInfo);
	    if(!CheckResult(iRet,"DIC_CMD:CHECK_REMOTE_INFO")) goto ENDFUNC;
   	    Memo1->Lines->Add("[OK]\r\n");

        //----------------------------------------------------------------------
        //Demo10: Get Current privilege
        //----------------------------------------------------------------------

        BYTE byPrivilege;

        Memo1->Lines->Add("******** Get current card privilege");

        iRet=Ry.Command(iDevID,GET_CARD_PRIVILEGE,&byPrivilege);
	    if(!CheckResult(iRet,"DIC_CMD:GET_CARD_PRIVILEGE")) goto ENDFUNC;

	    sprintf(chMsg,"Current card privilege is %02X",byPrivilege);
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");  


        //Check current remote information.

        Memo1->Lines->Add("******** Get current remote information");

        iRet=Ry.Command(iDevID,GET_REMOTE_INFO,&curRmtInfo);
	    if(!CheckResult(iRet,"DIC_CMD:GET_REMOTE_INFO")) goto ENDFUNC;

	    sprintf(chMsg,"RemoteTag is %08X, Remote password is ",curRmtInfo.RemoteTag);
	    for(i=0; i<8; i++)
        {
            char chTemp[8];

            sprintf(chTemp,"%02X ",curRmtInfo.RemotePass[i]);
            strcat(chMsg,chTemp);
        }
        Memo1->Lines->Add(chMsg);
	    Memo1->Lines->Add("[OK]\r\n");








        //----------------------------------------------------------------------
        // Demo15 : Close
        //----------------------------------------------------------------------

        iRet=Ry.Close(iDevID);
        if(!CheckResult(iRet,"DIC_Close")) goto ENDFUNC;

        sprintf(chMsg,"Rockey Closed.\r\n");
        Memo1->Lines->Add(chMsg);



ENDFUNC:


        Memo1->Lines->Add("\r\n[Test finished]");
}
//---------------------------------------------------------------------------



//Return 1 if succeeded.
//return 0 means failed.
int TForm1::CheckResult(int iRetCode, char* pFuncName)
{
    //TODO: Add your source code here
    int iRet=1;

    if(iRetCode<0)
    {
        char chMsg[256];

        sprintf(chMsg,"Error: %s failed, code %08x",pFuncName,iRetCode);
        Memo1->Lines->Add(chMsg);
        iRet=0;
    }

    return iRet;
}
