// ROCKEY.cpp: implementation of the CROCKEY class.
//
//////////////////////////////////////////////////////////////////////

#include "ROCKEY.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CROCKEY::CROCKEY()
{
	m_hDll=NULL;

	m_pDicFind=NULL;
	m_pDicOpen=NULL;
	m_pDicClose=NULL;
	m_pDicCmd=NULL;
    m_pGetVer=NULL;
    m_pGet=NULL;
    m_pSet=NULL;
    m_pFindMgr=NULL;

	if(Init()) m_bInitOK=0;
	else m_bInitOK=1;
}

CROCKEY::~CROCKEY()
{
	if(m_hDll) FreeLibrary(m_hDll);
}

//return 0 means succeeded.
//others mean failed.
int CROCKEY::Init()
{
	int iRet=0;

	m_hDll=LoadLibrary("DIC32U.dll");
	if(!m_hDll) iRet++;

	//GetProcAddress.
	m_pDicFind=(DICFIND)GetProcAddress(m_hDll,R5_FUNCNAME_FIND);
	if(!m_pDicFind) iRet++;

	m_pDicOpen=(DICOPEN)GetProcAddress(m_hDll,R5_FUNCNAME_OPEN);
	if(!m_pDicOpen) iRet++;

	m_pDicClose=(DICCLOSE)GetProcAddress(m_hDll,R5_FUNCNAME_CLOSE);
	if(!m_pDicClose) iRet++;

	m_pDicCmd=(DICCOMMAND)GetProcAddress(m_hDll,R5_FUNCNAME_CMD);
	if(!m_pDicCmd) iRet++;

        m_pGetVer=(DICGETVER)GetProcAddress(m_hDll,R5_FUNCNAME_VER);
   	if(!m_pGetVer) iRet++;
	
	m_pGet=(DICGet)GetProcAddress(m_hDll,"DIC_Get");
   	if(!m_pGet) iRet++;
	
	m_pSet=(DICSet)GetProcAddress(m_hDll,"DIC_Set");
   	if(!m_pSet) iRet++;
    m_pFindMgr=(DICFINDMGR)GetProcAddress(m_hDll,"DIC_FindByMgrCode");
   	if(!m_pFindMgr) iRet++;

	return iRet;
	
}

int CROCKEY::Find()
{
	return m_pDicFind();
}


int CROCKEY::Open(int hic, char* reader_name)
{
	return m_pDicOpen(hic,reader_name);
}

int CROCKEY::Close(DWORD dwHandle)
{
	return m_pDicClose(dwHandle);
}

int CROCKEY::Command(int hic, int cmd, void* cmddata)
{
	return m_pDicCmd(hic,cmd,cmddata);
}

int CROCKEY::GetVer(char* pVer)
{
    return m_pGetVer(pVer);
}

int CROCKEY::Get(void* xdata, int p1, int p2, char* buffer)
{
    return m_pGet(xdata,p1,p2,buffer);
}
int CROCKEY::Set(void* xdata, int p1, int p2, int p3, char* buffer)
{
    return m_pSet(xdata,p1,p2,p3,buffer);
}

int CROCKEY::FindMgr(PVOID pMgrCode)
{
    return m_pFindMgr(pMgrCode);
}
