// ==========================================================================
// Get hardware info
// (1) harware info
//	a) FactoryTime, the Date that ROCKEY was made
//	b) HardSerial, gloablly unqiue hardware serial number
//	c) ShipTime, the Date the ROCKEY was sold
//	d) COSVersion, the Card operation system version
// (2) Use DIC_Get to get info, we can set the last parameter to NULL
// ==========================================================================

unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls ,Dic32u;

type
    TForm1 = class(TForm)
    Button1: TButton;
    List: TListBox;
    procedure Button1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
end;

var
    Form1: TForm1;

implementation



{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
str:string;
errcode:Integer;    // error code
num:Integer;	    // number of reader
hic:Integer;        // device handle
i:Integer;
cmddata:array[0..256] of Char;
FactoryTime, HardSerial, ShipTime, COSVersion:LongWord;

begin
    List.Items.Clear();


    num := DIC_Find();
    for i:=0 to num-1 do
    begin
	    hic := DIC_Open(i, nil);
		if hic >= 0 then break;		//  Find the first ROCKEY
	end;
    if i = num then exit;

    errcode := DIC_Command(hic, GET_HARDWARE_INFO, cmddata);
    FactoryTime := DIC_Get(cmddata, FACTORY_TIME, BY_VALUE, nil);
    HardSerial := DIC_Get(cmddata, HARD_SERIAL, BY_VALUE, nil);
    ShipTime := DIC_Get(cmddata, SHIP_TIME, BY_VALUE, nil);
    COSVersion := DIC_Get(cmddata, COS_VERSION, BY_VALUE, nil);
    FmtStr(str,'FactoryTime  %x',[FactoryTime]);
    List.Items.Add(str);
    FmtStr(str,'HardSerial %x',[HardSerial]);
    List.Items.Add(str);
    FmtStr(str,'ShipTime   %x',[ShipTime]);
    List.Items.Add(str);
    FmtStr(str,'COSVersion   %s%s.%s%s', [char(COSVersion shr 24), char(COSVersion shr 16), char(COSVersion shr 8), char(COSVersion)]);
    List.Items.Add(str);

    errcode := DIC_Close(hic);
 
end;

end.


