// ==========================================================================
// Get supper password permission
// (1) the supper password is 8 bytes long, and should not enclose in end-user's software.
//      When the supper password is verified, you have the following permission
//      	a) creat or Delete excutable Files
//     	b) creat or Delete internal Files
//      	c) Format the ROCKEY(card)
//      	d) Reset supper password and Max password attempt 
//     	e) Get remote Update password
// (2) Demo ROCKEY's password is FF FF FF FF FF FF FF FF
// (3) GET_CARD_PRIVILEGE is used to get different permission. the retuned 
//	value in cmddata shhow the status
//    DICPR_NOPASS     0       ' supper password is not verified
//     DICPR_SUPERPASS  4       ' supper password is verified
//     DICPR_REMOTEPASS 8       ' remote update password is verified
// (4) User DIC_Get to get SUPERPASS_STATUS
//     SUPERPASS_STATUS 1     	'supper password is verified
//     SUPERPASS_STATUS 0     	'supper password is not verified
//     REMOTEPASS_STATUS is the same
// (5) when set supper password, you also need to set the max. attempt
// ==========================================================================
unit main;

interface

uses
    Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls,Dic32u ;

type
    TForm1 = class(TForm)
    Button1: TButton;
    List: TListBox;
    procedure Button1Click(Sender: TObject);
    private
        { Private declarations }
    public
        { Public declarations }
end;

var
    Form1: TForm1;

implementation



{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var

errcode:Integer;    // error code
num:Integer;	    // number of reader
hic:Integer;        // device handle
i:Integer;
cmddata:array[0..256] of Char;
buffer :array[0..256] of Char;
ifpass:integer;

begin
    List.Items.Clear();


    num := DIC_Find();
    for i:=0 to num-1 do
    begin
	    hic := DIC_Open(i, nil);
		if hic >= 0 then break;		//  Find the first ROCKEY
	end;
    if i = num then exit;

	// get permission info
    	errcode := DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
    	ifpass:=DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, nil);
    	if ifpass<>0 then
        	List.Items.Add('supper password is verified')
	else
        List.Items.Add('supper password is not verified');

	// Demo ROCKEY's password is FF FF FF FF FF FF FF FF
	for i:=0 to 7 do
        cmddata[i] := char($ff);
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// get permission info
	errcode := DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
        ifpass:=DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, nil);
	if ifpass<>0 then
        List.Items.Add('supper password is verified')
	else
        List.Items.Add('supper password is not verified');

	// Set password
	// new paasword in buffer(0 1 2 3 4 5 6 7)
	// set max. attempt (10) in p3 of DIC_Set
	for i:=0 to 7 do
        buffer[i] := char(i);
	DIC_Set(cmddata, SUPERPASS_DATA, BY_ARRAY, 10, buffer);
	errcode := DIC_Command(hic, SET_SUPER_PASS, cmddata);

	// cancel the supper password permission
	errcode := DIC_Close(hic);
	errcode := DIC_Open(hic, nil);

	// verify new supper password
	for i:=0 to 7 do
        cmddata[i] := char(i);
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// read SUPERPASS_STATUS
	errcode := DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
        ifpass :=DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, nil) ;
	if ifpass<>0 then
        List.Items.Add('supper password is verified')
	else
        List.Items.Add('supper password is not verified');

	// reset password to FF FF FF FF FF FF FF FF 
	for i:=0 to 7 do
        buffer[i] := char($ff);
	DIC_Set(cmddata, SUPERPASS_DATA, BY_ARRAY, 10, buffer);
	errcode := DIC_Command(hic, SET_SUPER_PASS, cmddata);

   errcode := DIC_Close(hic);
end;

end.


