// ==========================================================================
// RSA encryption/decryption
// Description: 
// If DES_RSA library is loaded, the DES, 3DES and RSA can be implemented by the following steps:
// (1) creat RSA key pair
// (2) encrypt/decrypt based on public key file ID or private key file ID
// Note:
// (1) the unit of key is bit, only support 1024 or 512 bits key
// (2) the default value of e is 65537, and cannot be changed
// (3) when encrypt data, if the data is longer than n, please set the high bit of data to 0
// ==========================================================================
unit main;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls ,Dic32u;

type
  TForm1 = class(TForm)
  Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure SampleEntry();


var
   i,j,num,hic,errcode:Integer;
   cmddata:Array[0..255]of byte;
   EncData,dataSrc:Array[0..127]of byte;
   str,strtmp:string;
	wRetLen:WORD;
begin
   num := DIC_Find();
   i:=0;
   while(i<num) do
	begin
		hic := DIC_Open(i, nil);
		if (hic >= 0) then break;		// Find the first ROCKEY
      i:=i+1;
	end;
	if (i = num) then exit;
   
   for i:=0 to 7 do
       cmddata[i] := byte($ff); // demo password is 8 'FF's
	errcode := DIC_Command(hic, CHECK_SUPER_PASS, @cmddata);
   if(errcode<>0) then showMessage('CHECK_SUPER_PASS err');
   
	//format
	DIC_Set(@cmddata, VOLUME, BY_ARRAY, 0, 'ggggg');
	DIC_Set(@cmddata, ATR, BY_ARRAY, 0, '111111');
	errcode := DIC_Command(hic, FORMAT_CARD, @cmddata);
   if(errcode<>0) then showMessage('format err');
   

   	//////////////////////////////////////////////////////////////////////////
	//generate RSA key pair
   
	DIC_Set(@cmddata, RSA_PUBKEYID, BY_VALUE, $7f01, nil); 	//public key file ID
	DIC_Set(@cmddata, RSA_PUBKEYSIZE, BY_VALUE, 1024, nil); //public key size in bit
	DIC_Set(@cmddata, RSA_PIVKEYID, BY_VALUE, $7f02, nil); 	//private key file ID
	errcode := DIC_Command(hic, RSAGENKEY, @cmddata);
	if (errcode <> SCARD_S_SUCCESS) then 
   begin 
		ShowMessage('RSAGENKEY error');
	end; 
   
   str:='Rsa encrypte'+#13#10+'plaintext'+#13#10;
	//plaintext
	for i := 0 to 127 do
   begin 
		dataSrc[i] := i;
      if i=127 then dataSrc[i] := dataSrc[i] and $7f;  //the high byte is 0
      FmtStr(strTmp,'%02x ',[dataSrc[i]]);
      str:=str+strTmp;
      if(((i+1) mod 16) = 0) then
         str:= str+#13#10;
	end;
	
	//RSA encryption, either public key or private key
	DIC_Set(@cmddata, RSA_KEYFILEID, BY_VALUE, $7f01, nil); //use public key here
	DIC_Set(@cmddata, RSA_DATA, BY_ARRAY or 128, 0, @dataSrc);
	errcode := DIC_Command(hic, RSAENC, @cmddata);//if use private key, please use'RSADEC'
	if (errcode <> SCARD_S_SUCCESS) then
	begin 
		ShowMessage('RSA enc error ');
	end 
   else 
	begin 
		wRetLen := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @EncData);
		//ShowMessage('Get %d Cipher text:'#10'',wRetLen);
      str:=str+#13#10+'cypher text'+#13#10;
		for i := 0 to wRetLen-1 do
      begin 
         FmtStr(strTmp,'%02x ',[EncData[i]]);
         str:=str+strTmp;
         if(((i+1) mod 16) = 0) then
            str:= str+#13#10;
	   end; 
	end; 

	//RSA decryption
	DIC_Set(@cmddata, RSA_KEYFILEID, BY_VALUE, $7f02, nil);
	DIC_Set(@cmddata, RSA_DATA, BY_ARRAY or 128, 0, @EncData);
	errcode := DIC_Command(hic, RSADEC, @cmddata);
	if (errcode <> SCARD_S_SUCCESS) then 
	begin 
		ShowMessage('RSA dec error');
	end else 
	begin 
		wRetLen := DIC_Get(@cmddata, AFTER_ENCDEC_DATA, BY_ARRAY, @EncData);
		//ShowMessage('Get %d plant text:'#10'',wRetLen);
		str:=str+#13#10+'decrypted result'+#13#10;
		for i := 0 to wRetLen-1 do
      begin 
         FmtStr(strTmp,'%02x ',[EncData[i]]);
         str:=str+strTmp;
         if(((i+1) mod 16) = 0) then
            str:= str+#13#10;
	   end; 
	end; 


	////////////////////////////////////////////////////
   ShowMessage(str);
   errcode := DIC_Close(hic);
end;


procedure TForm1.FormCreate(Sender: TObject);

begin
   SampleEntry();

end;

end.
