! ==========================================================================
! Demo: Double-precision Float Point Calculation 
! Caution: no error check for the sake of briefness and understandability
! Tips:
! You can use Double-precision float data in dongle program. ROCKEY5 have complete 
! support for it. It can give more security.
! ==========================================================================
! Calculation formula:
! x = x*cos@-y*sin@
! y = x*sin@+y*cos@
!
! Input 24 bytes(8 bytes for each double data):
! x in 0-7 bytes
! y in 8-15 bytes
! @ in 16-23 bytes, radian
! output:
! x in 0-7 bytes
! y in 8-15 bytes
! ==========================================================================
!void main()
!{
!unsigned char buf[24];
!unsigned char x[8],y[8],deta[8];
!unsigned char cosdeta[8],sindeta[8];
!unsigned char xcos[8],xsin[8],ycos[8],ysin[8];
 
!get_input(buf,0,0,24);
! memcpy(x,buf,8);
! memcpy(y,buf+8,8);
! memcpy(deta,buf+16,8);
!double_cos(deta,cosdeta);
!double_sin(deta,sindeta);
!double_mul(x,cosdeta,xcos);
!double_mul(x,sindeta,xsin);
!double_mul(y,cosdeta,ycos);
!double_mul(y,sindeta,ysin);
!double_sub(xcos,ysin,x);
!double_add(xsin,ycos,y);
!memcpy(buf,x,8);
!memcpy(buf+8,y,8);
!set_response(16,buf);
!exit();
!}
! ==========================================================================

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code 
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device.
integer*4 i 
integer*4 ret_code 
CHARACTER*256 reader_name
CHARACTER cmddata(512) 	
CHARACTER buffer(256) 	
CHARACTER*20  p_null
real*8   x, y, x1, y1, delta
integer*4,parameter :: DOUBLE_SIZE= 865
CHARACTER g_progDOUBLE(DOUBLE_SIZE)
data g_progDOUBLE /#02,#03,#51,#75,#68,#00,#75,#69,#00,#75,#6a,#08,#e4,#f5,#6b,#f5, &
#6c,#75,#6d,#18,#12,#03,#1b,#78,#20,#7c,#00,#7d,#00,#7b,#00,#7a, &
#00,#79,#08,#7e,#00,#7f,#08,#12,#02,#36,#78,#28,#7c,#00,#7d,#00, &
#7b,#00,#7a,#00,#79,#10,#7e,#00,#7f,#08,#12,#02,#36,#78,#30,#7c, &
#00,#7d,#00,#7b,#00,#7a,#00,#79,#18,#7e,#00,#7f,#08,#12,#02,#36, &
#75,#68,#00,#75,#69,#00,#75,#6a,#30,#75,#6b,#00,#75,#6c,#00,#75, &
#6d,#38,#12,#02,#dd,#75,#68,#00,#75,#69,#00,#75,#6a,#30,#75,#6b, &
#00,#75,#6c,#00,#75,#6d,#40,#12,#02,#fc,#75,#68,#00,#75,#69,#00, &
#75,#6a,#20,#75,#6b,#00,#75,#6c,#00,#75,#6d,#38,#75,#6e,#00,#75, &
#6f,#00,#75,#70,#48,#12,#02,#87,#75,#68,#00,#75,#69,#00,#75,#6a, &
#20,#75,#6b,#00,#75,#6c,#00,#75,#6d,#40,#75,#6e,#00,#75,#6f,#00, &
#75,#70,#50,#12,#02,#87,#75,#68,#00,#75,#69,#00,#75,#6a,#28,#75, &
#6b,#00,#75,#6c,#00,#75,#6d,#38,#75,#6e,#00,#75,#6f,#00,#75,#70, &
#58,#12,#02,#87,#75,#68,#00,#75,#69,#00,#75,#6a,#28,#75,#6b,#00, &
#75,#6c,#00,#75,#6d,#40,#75,#6e,#00,#75,#6f,#00,#75,#70,#60,#12, &
#02,#87,#75,#68,#00,#75,#69,#00,#75,#6a,#48,#75,#6b,#00,#75,#6c, &
#00,#75,#6d,#60,#75,#6e,#00,#75,#6f,#00,#75,#70,#20,#12,#02,#b2, &
#75,#68,#00,#75,#69,#00,#75,#6a,#50,#75,#6b,#00,#75,#6c,#00,#75, &
#6d,#58,#75,#6e,#00,#75,#6f,#00,#75,#70,#28,#12,#02,#5c,#78,#08, &
#7c,#00,#7d,#00,#7b,#00,#7a,#00,#79,#20,#7e,#00,#7f,#08,#12,#02, &
#36,#78,#10,#7c,#00,#7d,#00,#7b,#00,#7a,#00,#79,#28,#7e,#00,#7f, &
#08,#12,#02,#36,#75,#68,#10,#75,#69,#00,#75,#6a,#00,#75,#6b,#08, &
#12,#03,#3a,#02,#03,#5d,#e7,#09,#f6,#08,#df,#fa,#80,#46,#e7,#09, &
#f2,#08,#df,#fa,#80,#3e,#88,#82,#8c,#83,#e7,#09,#f0,#a3,#df,#fa, &
#80,#32,#e3,#09,#f6,#08,#df,#fa,#80,#78,#e3,#09,#f2,#08,#df,#fa, &
#80,#70,#88,#82,#8c,#83,#e3,#09,#f0,#a3,#df,#fa,#80,#64,#89,#82, &
#8a,#83,#e0,#a3,#f6,#08,#df,#fa,#80,#58,#89,#82,#8a,#83,#e0,#a3, &
#f2,#08,#df,#fa,#80,#4c,#80,#d2,#80,#fa,#80,#c6,#80,#d4,#80,#69, &
#80,#f2,#80,#33,#80,#10,#80,#a6,#80,#ea,#80,#9a,#80,#a8,#80,#da, &
#80,#e2,#80,#ca,#80,#33,#89,#82,#8a,#83,#ec,#fa,#e4,#93,#a3,#c8, &
#c5,#82,#c8,#cc,#c5,#83,#cc,#f0,#a3,#c8,#c5,#82,#c8,#cc,#c5,#83, &
#cc,#df,#e9,#de,#e7,#80,#0d,#89,#82,#8a,#83,#e4,#93,#a3,#f6,#08, &
#df,#f9,#ec,#fa,#a9,#f0,#ed,#fb,#22,#89,#82,#8a,#83,#ec,#fa,#e0, &
#a3,#c8,#c5,#82,#c8,#cc,#c5,#83,#cc,#f0,#a3,#c8,#c5,#82,#c8,#cc, &
#c5,#83,#cc,#df,#ea,#de,#e8,#80,#db,#89,#82,#8a,#83,#e4,#93,#a3, &
#f2,#08,#df,#f9,#80,#cc,#88,#f0,#ef,#60,#01,#0e,#4e,#60,#c3,#88, &
#f0,#ed,#24,#02,#b4,#04,#00,#50,#b9,#f5,#82,#eb,#24,#02,#b4,#04, &
#00,#50,#af,#23,#23,#45,#82,#23,#90,#01,#b6,#73,#12,#ff,#00,#e5, &
#68,#24,#00,#e5,#69,#24,#01,#e5,#6a,#24,#02,#e5,#6b,#24,#03,#e5, &
#6c,#24,#04,#e5,#6d,#24,#05,#e5,#6e,#24,#06,#e5,#6f,#24,#07,#e5, &
#70,#24,#08,#12,#ff,#26,#22,#12,#ff,#00,#e5,#68,#24,#00,#e5,#69, &
#24,#01,#e5,#6a,#24,#02,#e5,#6b,#24,#03,#e5,#6c,#24,#04,#e5,#6d, &
#24,#05,#e5,#6e,#24,#06,#e5,#6f,#24,#07,#e5,#70,#24,#08,#12,#ff, &
#28,#22,#12,#ff,#00,#e5,#68,#24,#00,#e5,#69,#24,#01,#e5,#6a,#24, &
#02,#e5,#6b,#24,#03,#e5,#6c,#24,#04,#e5,#6d,#24,#05,#e5,#6e,#24, &
#06,#e5,#6f,#24,#07,#e5,#70,#24,#08,#12,#ff,#27,#22,#12,#ff,#00, &
#e5,#68,#24,#00,#e5,#69,#24,#01,#e5,#6a,#24,#02,#e5,#6b,#24,#03, &
#e5,#6c,#24,#04,#e5,#6d,#24,#05,#12,#ff,#32,#22,#12,#ff,#00,#e5, &
#68,#24,#00,#e5,#69,#24,#01,#e5,#6a,#24,#02,#e5,#6b,#24,#03,#e5, &
#6c,#24,#04,#e5,#6d,#24,#05,#12,#ff,#31,#22,#12,#ff,#00,#e5,#68, &
#24,#00,#e5,#69,#24,#01,#e5,#6a,#24,#02,#e5,#6b,#24,#03,#e5,#6c, &
#24,#04,#e5,#6d,#24,#05,#12,#ff,#0b,#22,#12,#ff,#00,#e5,#69,#24, &
#00,#e5,#6a,#24,#01,#e5,#6b,#24,#02,#e5,#68,#24,#03,#12,#ff,#0a, &
#22,#78,#7f,#e4,#f6,#d8,#fd,#75,#81,#70,#02,#00,#03,#12,#ff,#0d, &
#22/


	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		!  Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	! a. Check supper password,it's required by writing process.
	do i=1 ,8
	cmddata(i)=char(255)  !Super password is 8 FFs for demo ROCKEY
	enddo		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata)) 
	
	! b. Create exe-file.
	ret_code=DIC_Set(loc(cmddata), FILL, 512, 0, loc(p_null)) 				! Clear buffer
	ret_code=DIC_Set(loc(cmddata), FILE_ID, BY_VALUE, #0045, loc(p_null)) 			! File ID
	ret_code=DIC_Set(loc(cmddata), FILE_CLASS, BY_VALUE, #ff, loc(p_null)) 			! File class
	ret_code=DIC_Set(loc(cmddata), FILE_ATTRIBUTE, BY_VALUE, FILEATTR_EXEC, loc(p_null)) 	! File attr 
	ret_code=DIC_Set(loc(cmddata), FILE_SIZE, BY_VALUE, DOUBLE_SIZE, loc(p_null)) 		! File attr
	data buffer /'7','0','0','2'/
	ret_code=DIC_Set(loc(cmddata), FILE_NAME, BY_ARRAY, 0, loc(buffer)) 
	errcode = DIC_Command(hic, CREATE_FILE, loc(cmddata)) 

	! c. Write exe-file
	ret_code=DIC_Set(loc(cmddata), WRITE_DATA, DOUBLE_SIZE, 0, loc(g_progDOUBLE) )
	errcode = DIC_Command(hic, WRITE_FILE, loc(cmddata)) 

	! d. return to password not verified status
	!    we cannot run program at super password verified status.
	errcode = DIC_Close(hic) 
	errcode = DIC_Open(hic, loc(p_null)) 

	! e. run
	x = 2.4784 
	y = 3.59884 
	delta = 0.7853981634 
	ret_code=DIC_Set(loc(buffer), 0, IOR(BY_ARRAY, 8), 0, loc(x))  		! set x
	ret_code=DIC_Set(loc(buffer), 8, IOR(BY_ARRAY , 8), 0, loc(y))  	! set y
	ret_code=DIC_Set(loc(buffer), 16, IOR(BY_ARRAY , 8), 0, loc(delta))  	! set delta
	ret_code=DIC_Set(loc(cmddata), RUN_DATA, 24, #7002, loc(buffer)) 	! set data
	errcode = DIC_Command(hic, RUN, loc(cmddata)) 
	ret_code=DIC_Get(loc(cmddata), RUN_DATA, BY_ARRAY, loc(buffer)) 	! get data
	ret_code=DIC_Get(loc(buffer), 0, IOR(BY_ARRAY , 8), loc(x1)) 		! get x
	ret_code=DIC_Get(loc(buffer), 8, IOR(BY_ARRAY , 8), loc(y1)) 		! get y

	write(*,'(f,f)') x1, y1 
	errcode = DIC_Close(hic) 

	! f. the result of computer
	x1 = x*cos(delta) - y*sin(delta) 
	y1 = x*sin(delta) + y*cos(delta) 

    write(*,'(f,f)') x1, y1
	
end

	