! ==========================================================================
!' DES and 3DES Encryption and Decryption
! Description: 
! If DES_RSA library is loaded, the DES, 3DES and RSA can be implemented by the following steps:
!  (1) creat a internal data file (supper password is needed)
!  (2) write DES, RSA key (supper password is needed)
!  (3) encrypt/decrypt based on file ID and key ID. 
!	when encrypt, the length of data should be A*8, where A is an integer, otherwise the data will be filled automatically.
! 	when decrypt, please cut off the corresponding data.
! Note:
! (1)DES Key is 8 bytes, and 3DES key is 16 bytes
! (2)The struct for DES and 3DES key
!	DES Key struct (10 bytes): key ID (1 byte)+key length(1 byte, value is 8)+key(8 bytes)
!	3DES Key struct (18 bytes): key ID (1 byte)+key length(1 byte, value is 16)+key(16 byte)
! ========================================================================== 

!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code 
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey5 device.
integer*4 i ,j
integer*4 ret_code 
CHARACTER*256 reader_name
CHARACTER cmddata(512) 
CHARACTER buffer(256) 
CHARACTER*256 buffer2
CHARACTER*20  p_null
CHARACTER c_temp(20) 	



	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		!! Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	! a. Change to super user status (Only super users are allowed to create executable files)
	do i=1 ,8
	cmddata(i)=char(255)  ! Super password is 8 FFs for demo ROCKEY
	enddo		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata)) 
	
	! b. Format ROCKEY, all files and directorys will be cleared.
	!    You can set ATR and VOLUME here.
	buffer2 ='DICSYSTEM'C
	ret_code=DIC_Set(loc(cmddata), VOLUME, BY_ARRAY, 0, loc(buffer2)) 
	buffer2 ='DIC Co.'c
	ret_code=DIC_Set(loc(cmddata), ATR, BY_ARRAY, 0,loc(buffer2) ) 
	errcode = DIC_Command(hic, FORMAT_CARD, loc(cmddata))
	
	! create a key file for DES or TDES(3DES)| FILEATTR_INTERNAL
	! file ID 0x6F01
	ret_code=DIC_Set(loc(cmddata), FILL, 256, 0, loc(p_null))			! clear buffer
	ret_code=DIC_Set(loc(cmddata), FILE_ID, BY_VALUE, #6F01, 0)			! file ID
	ret_code=DIC_Set(loc(cmddata), FILE_CLASS, BY_VALUE, 255, 0)			! file class
	ret_code=DIC_Set(loc(cmddata), FILE_ATTRIBUTE, BY_VALUE, FILEATTR_NORMAL, 0)	! file attr, internal
	ret_code=DIC_Set(loc(cmddata), FILE_SIZE, BY_VALUE, 28, 0)			! file size
	ret_code=DIC_Set(loc(cmddata), FILE_NAME, BY_ARRAY, 0,loc('deskey'))		! file name
	errcode = DIC_Command(hic, CREATE_FILE, loc(cmddata))


    	! write 8 bytes DES key, note the struct
	ret_code=DIC_Set(loc(buffer),0,1,1,0)
	ret_code=DIC_Set(loc(buffer),1,1,8,0)
	do i=2,9
		ret_code=DIC_Set(loc(buffer),i,1,i-2,0)
	enddo
	ret_code=DIC_Set(loc(cmddata), WRITE_DATA, 10, 0, loc(buffer))
	errcode = DIC_Command(hic, WRITE_FILE, loc(cmddata))
	
    
    	! write 16 bytes 3DES key, not the struct
    	! the offset is 10
	ret_code=DIC_Set(loc(buffer),0,1,2,0)
	ret_code=DIC_Set(loc(buffer),1,1,16,0)
	do i=2,17
		ret_code=DIC_Set(loc(buffer),i,1,i-2,0)
	enddo
	ret_code=DIC_Set(loc(cmddata), WRITE_DATA, 18, 10, loc(buffer))
	errcode = DIC_Command(hic, WRITE_FILE, loc(cmddata))


	! cancle the supper password status
	errcode = DIC_Close(hic) 
	errcode = DIC_Open(hic, loc(p_null)) 
	
!================================des encrypt =8=========================================!
	do i=0,7
		ret_code=DIC_Set(loc(buffer),i,1,i,0)
	enddo
	
	ret_code=DIC_Set(loc(cmddata),DES_KEYFILEID,0,#6F01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_KEYINDEX,0,#01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_DATA,BY_ARRAY + 8,0,loc(buffer))
	errcode = DIC_Command(hic, DESENC, loc(cmddata))
	wRet = DIC_Get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))

	write(*,*) 'Des'
	write(*,*) 'Cipher text:'
	write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)') buffer(1), &
	buffer(2),buffer(3),buffer(4),buffer(5),buffer(6),buffer(7),buffer(8)
	
!================================des decrypt =8=========================================!

	ret_code=DIC_Set(loc(cmddata),DES_KEYFILEID,0,#6F01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_KEYINDEX,0,#01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_DATA,BY_ARRAY + 8,0,loc(buffer))
	errcode = DIC_Command(hic, DESDEC, loc(cmddata))
	wRet = DIC_Get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))

	
	write(*,*) 'plant text:'
	write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)') buffer(1), &
	buffer(2),buffer(3),buffer(4),buffer(5),buffer(6),buffer(7),buffer(8)

	!================================3des encrypt =8=========================================!
	do i=0,7
		ret_code=DIC_Set(loc(buffer),i,1,i,0)
	enddo
	
	ret_code=DIC_Set(loc(cmddata),DES_KEYFILEID,0,#6F01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_KEYINDEX,0,#02,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_DATA,BY_ARRAY + 8,0,loc(buffer))
	errcode = DIC_Command(hic, DESENC, loc(cmddata))
	wRet = DIC_Get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))

	write(*,*) 'Des'
	write(*,*) 'Cipher text:'
	write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)') buffer(1), &
	buffer(2),buffer(3),buffer(4),buffer(5),buffer(6),buffer(7),buffer(8)
	
!================================3des decrypt =8=========================================!

	ret_code=DIC_Set(loc(cmddata),DES_KEYFILEID,0,#6F01,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_KEYINDEX,0,#02,loc(p_null))
	ret_code=DIC_Set(loc(cmddata),DES_DATA,BY_ARRAY + 8,0,loc(buffer))
	errcode = DIC_Command(hic, DESDEC, loc(cmddata))
	wRet = DIC_Get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))

	
	write(*,*) 'plant text:'
	write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)') buffer(1), &
	buffer(2),buffer(3),buffer(4),buffer(5),buffer(6),buffer(7),buffer(8)
	
	! m. close
	errcode = DIC_Close(hic) 
end

	