!==========================================================================
! RSA encryption/decryption
! Description: 
! If DES_RSA library is loaded, the DES, 3DES and RSA can be implemented by the following steps:
! (1) creat RSA key pair
! (2) encrypt/decrypt based on public key file ID or private key file ID
! Note:
! (1) the unit of key is bit, only support 1024 or 512 bits key
! (2) the default value of e is 65537, and cannot be changed
! (3) when encrypt data, if the data is longer than n, please set the high byte of data to 0
!==========================================================================
!DEC$FREEFORM

INCLUDE 'head.F90'

integer*4 errcode 			! error code 
integer*4 num 				! number of founded card reader(s)
integer*4 hic 				! handle of Rockey device.
integer*4 i ,j
integer*4 ret_code 
CHARACTER*256 reader_name
CHARACTER cmddata(512) 	
CHARACTER buffer(256) 	
CHARACTER*256 buffer2
CHARACTER*20  p_null
CHARACTER c_temp(20) 	



	num = DIC_Find() 
	do i=0 ,num-1
		hic = DIC_Open(i, loc(reader_name)) 
		if (hic >= 0) then
		exit
		endif		! Stop searching once one is found.
	enddo

	if (i == num)  then
        	stop
	endif

	! a. Change to super user status (Only super users are allowed to create executable files)
	do i=1 ,8
	cmddata(i)=char(255)  ! Super password is 8 FFs for demo ROCKEY
	enddo		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, loc(cmddata)) 
	
	! b. Format ROCKEY, all files and directorys will be cleared.
	!    You can set ATR and VOLUME here.
	buffer2 ='DICSYSTEM'C
	ret_code=DIC_Set(loc(cmddata), VOLUME, BY_ARRAY, 0, loc(buffer2)) 
	buffer2 ='DIC Co.'c
	ret_code=DIC_Set(loc(cmddata), ATR, BY_ARRAY, 0,loc(buffer2) ) 
	!errcode = DIC_Command(hic, FORMAT_CARD, loc(cmddata))

	!********************************************
	!Generate RSA key pair
	ret_code=DIC_set(loc(cmddata), RSA_PUBKEYID, BY_VALUE, #7f01, 0) 	!public key file ID
	ret_code=DIC_set(loc(cmddata), RSA_PUBKEYSIZE, BY_VALUE, 1024, 0) 	!public key size in bit
	ret_code=DIC_set(loc(cmddata), RSA_PIVKEYID, BY_VALUE, #7f02, 0) 	!private key file ID
	errcode = DIC_Command(hic, RSAGENKEY, loc(cmddata))

	! cancel the supper password status
	errcode = DIC_Close(hic) 
	errcode = DIC_Open(hic, loc(p_null)) 
	
	!set plaintext
	do i = 1 ,128
		buffer(i)=char(i)
	enddo
	
	!RSA encryption, either public key or private key
	ret_code=DIC_set(loc(cmddata), RSA_KEYFILEID, BY_VALUE, #7f01, 0) !use public key here
	ret_code=DIC_set(loc(cmddata), RSA_DATA, BY_ARRAY + 128, 0, loc(buffer))
	errcode = DIC_Command(hic, RSAENC, loc(cmddata))
	
	ret_code=DIC_get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))
	write(*,*) 'RSA: decrypt 128 bytes'	
	write(*,*) 'Cipher text:'
	do i=0,15
		write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)')  & 
		buffer(1+i*8),buffer(2+i*8),buffer(3+i*8),buffer(4+i*8),buffer(5+i*8),buffer(6+i*8),buffer(7+i*8),buffer(8+i*8)
	end do

	ret_code=DIC_set(loc(cmddata), RSA_KEYFILEID, BY_VALUE, #7f02, 0) !encrypt with the public key
	ret_code=DIC_set(loc(cmddata), RSA_DATA, BY_ARRAY + 128, 0, loc(buffer))
	errcode = DIC_Command(hic, RSADEC, loc(cmddata))
	
	ret_code=DIC_get(loc(cmddata), AFTER_ENCDEC_DATA, BY_ARRAY, loc(buffer))
	write(*,*) ''
	write(*,*) 'plant text:'
	do i=0,15
		write(*,'(z3,z3,z3,z3,z3,z3,z3,z3)')  & 
		buffer(1+i*8),buffer(2+i*8),buffer(3+i*8),buffer(4+i*8),buffer(5+i*8),buffer(6+i*8),buffer(7+i*8),buffer(8+i*8)
	end do

	
	! m. close
	errcode = DIC_Close(hic) 
end

	