// ==========================================================================
// DES and 3DES Encryption and Decryption
// Description: 
// If DES_RSA library is loaded, the DES, 3DES and RSA can be implemented by the following steps:
//  (1) creat a internal data file (supper password is needed)
//  (2) write DES, RSA key (supper password is needed)
//  (3) encrypt/decrypt based on file ID and key ID. 
//	when encrypt, the length of data should be A*8, where A is an integer, otherwise the data will be filled automatically.
// 	when decrypt, please cut off the corresponding data.
// Note:
// (1)DES Key is 8 bytes, and 3DES key is 16 bytes
// (2)The struct for DES and 3DES key
//	DES Key struct (10 bytes): key ID (1 byte)+key length(1 byte, value is 8)+key(8 bytes)
//	3DES Key struct (18 bytes): key ID (1 byte)+key length(1 byte, value is 16)+key(16 byte)
// ==========================================================================

import java.io.*;

public class Sample14
{
	public Sample14()
	{
	}
	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte []cmddata=new byte[256],outData=new byte[40],data=new byte[40];
	    	byte DesData[]={(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44,(byte)0x55,(byte)0x66,(byte)0x77,(byte)0x88,(byte)0x99};  //data for des encrypt =8
		int wRet,dataLength = 8;
		int key1[]={0x01,0x08,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
		int key2[]={0x02,0x10,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10};
		JavaRockey Rockey=new JavaRockey();
		System.out.println("Searching ROCKEEY ");
		num = Rockey.DIC_Find();
		if (num <= 0)
		{
			System.out.println("find the first ROCKEY");
			return;
		}
		System.out.println(num);
	
		System.out.println("Open ROCKEY");
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, null);	
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num)
		{
			System.out.println("find the first ROCKEY");
			return;
		}
		
		//verify supper password
		for(i=0;i<8;i++) cmddata[i]=(byte)0xff;
		errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
		if (errcode != Rockey.SCARD_S_SUCCESS) {
			System.out.println("Verify Super Pass error : "+Integer.toHexString(errcode));
		}
	
		//format the ROCKEY, all info will be deleted, you can set new ROCKEY info
		Rockey.DIC_Set(cmddata, Rockey.VOLUME, Rockey.BY_ARRAY, 0, "DEFAULT VOL\0".getBytes());
		Rockey.DIC_Set(cmddata, Rockey.ATR, Rockey.BY_ARRAY, 0, "DEFAULT ATR\0".getBytes());
		errcode = Rockey.DIC_Command(hic, Rockey.FORMAT_CARD, cmddata);
		if (errcode != Rockey.SCARD_S_SUCCESS) {
			System.out.println("Format card error: "+Integer.toHexString(errcode));
		}
	
	
		// create a file for DES or TDES(3DES)
		// file ID $6F01
		Rockey.DIC_Set(cmddata, Rockey.FILL, 256, 0, null);					// clear buffer
		Rockey.DIC_Set(cmddata, Rockey.FILE_ID, Rockey.BY_VALUE, 0x6F01, null);			// file ID
		Rockey.DIC_Set(cmddata, Rockey.FILE_CLASS, Rockey.BY_VALUE, 0xff, null);		// file class
		Rockey.DIC_Set(cmddata, Rockey.FILE_ATTRIBUTE, Rockey.BY_VALUE, Rockey.FILEATTR_NORMAL | Rockey.FILEATTR_INTERNAL, null);	// file attr, internal
		Rockey.DIC_Set(cmddata, Rockey.FILE_SIZE, Rockey.BY_VALUE, 128, null);			// file size
		Rockey.DIC_Set(cmddata, Rockey.FILE_NAME, Rockey.BY_ARRAY, 0, "des\0".getBytes());	// file name
		errcode = Rockey.DIC_Command(hic, Rockey.CREATE_FILE, cmddata);
		if(errcode != Rockey.SCARD_S_SUCCESS){
			System.out.println("Create Des file error: "+Integer.toHexString(errcode));
		}
	
	
	    	// write 8 bytes DES key, note the struct
		for(i=0;i<10;i++) data[i]=(byte)key1[i];
		Rockey.DIC_Set(cmddata, Rockey.WRITE_DATA, 10, 0, data);
		errcode = Rockey.DIC_Command(hic, Rockey.WRITE_FILE, cmddata);
		if(errcode != Rockey.SCARD_S_SUCCESS){
			System.out.println("Write Des key file error: "+Integer.toHexString(errcode));
		}
	       
   	 	//write 18 bytes 3DES key, note the struct
		// the offset is 10 when write the key
		for(i=0;i<18;i++) data[i]=(byte)key2[i];
		Rockey.DIC_Set(cmddata, Rockey.WRITE_DATA, 18, 10, data);
		errcode= Rockey.DIC_Command(hic, Rockey.WRITE_FILE, cmddata);
		if(errcode != Rockey.SCARD_S_SUCCESS){
			System.out.println("Write Des key file error: "+Integer.toHexString(errcode));
		}
	
	//================================des encrypt =8=========================================//
		System.out.println("des: ");
		System.out.println(" Plain text: ");
		for(i= 0 ;i<dataLength;i++){
			System.out.print(Integer.toHexString(DesData[i]&0xff)+" ");
		}
		System.out.println("");
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYFILEID,0,0x6F01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYINDEX,0,0x01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_DATA,Rockey.BY_ARRAY | dataLength,0,DesData);
		errcode = Rockey.DIC_Command(hic, Rockey.DESENC, cmddata);
		wRet = Rockey.DIC_Get(cmddata, Rockey.AFTER_ENCDEC_DATA, Rockey.BY_ARRAY, outData);
		System.out.println("Cipher text: ");
		for(i = 0;i<wRet;i++){
			System.out.print(Integer.toHexString(outData[i]&0xff)+" ");
		}
		System.out.println("");	
			
	 //====================================des decrypt =8===================================//  
	   		
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYFILEID,0,0x6F01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYINDEX,0,0x01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_DATA,Rockey.BY_ARRAY|wRet,0,outData);
		errcode = Rockey.DIC_Command(hic, Rockey.DESDEC, cmddata);
		wRet = Rockey.DIC_Get(cmddata, Rockey.AFTER_ENCDEC_DATA, Rockey.BY_ARRAY, DesData);
	    	System.out.println(" Plain text: ");
		for(i= 0 ;i<wRet;i++){
			System.out.print(Integer.toHexString(DesData[i]&0xff)+" ");
		}
		System.out.println("");	
	
		//================================3des encrypt =8=========================================//
		System.out.println("3des: ");
		System.out.println("Plain text: ");
		for(i= 0 ;i<dataLength;i++){
			System.out.print(Integer.toHexString(DesData[i]&0xff)+" ");
		}
		System.out.println("");
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYFILEID,0,0x6F01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYINDEX,0,0x02,null); //3des key ID is 2
		Rockey.DIC_Set(cmddata,Rockey.DES_DATA,Rockey.BY_ARRAY | dataLength,0,DesData);
		errcode = Rockey.DIC_Command(hic, Rockey.DESENC, cmddata);
		wRet = Rockey.DIC_Get(cmddata, Rockey.AFTER_ENCDEC_DATA, Rockey.BY_ARRAY, outData);
		System.out.println("Cipher text: ");
		for(i = 0;i<wRet;i++){
			System.out.print(Integer.toHexString(outData[i]&0xff)+" ");
		}
		System.out.println("");	
			
	 //====================================3des decrypt =8===================================//  
	   		
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYFILEID,0,0x6F01,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_KEYINDEX,0,0x02,null);
		Rockey.DIC_Set(cmddata,Rockey.DES_DATA,Rockey.BY_ARRAY|wRet,0,outData);
		errcode = Rockey.DIC_Command(hic, Rockey.DESDEC, cmddata);
		wRet = Rockey.DIC_Get(cmddata, Rockey.AFTER_ENCDEC_DATA, Rockey.BY_ARRAY, DesData);
	    	System.out.println("Plain text: ");
		for(i= 0 ;i<wRet;i++){
			System.out.print(Integer.toHexString(DesData[i]&0xff)+" ");
		}
		System.out.println("");
	}

}