// ==========================================================================
// Get hardware info
// (1) harware info
//	a) FactoryTime, the Date that ROCKEY was made
//	b) HardSerial, gloablly unqiue hardware serial number
//	c) ShipTime, the Date the ROCKEY was sold
//	d) COSVersion, the Card operation system version
// (2) Use DIC_Get to get info, we can set the last parameter to NULL
// ==========================================================================

import java.io.*;

public class Sample5
{
	public Sample5()
	{
	}

	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte []cmddata=new byte[256];	// command buffer
		byte []buffer=new byte[256];	// user buffer
		int FactoryTime, HardSerial, ShipTime, COSVersion;
		char []name=new char[256];
		
		JavaRockey Rockey=new JavaRockey();
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, name);
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num) return;
	
		errcode = Rockey.DIC_Command(hic, Rockey.GET_HARDWARE_INFO, cmddata);
		FactoryTime = Rockey.DIC_Get(cmddata, Rockey.FACTORY_TIME, Rockey.BY_VALUE, buffer);
		HardSerial = Rockey.DIC_Get(cmddata, Rockey.HARD_SERIAL, Rockey.BY_VALUE, buffer);
		ShipTime = Rockey.DIC_Get(cmddata, Rockey.SHIP_TIME, Rockey.BY_VALUE, buffer);
		COSVersion = Rockey.DIC_Get(cmddata, Rockey.COS_VERSION, Rockey.BY_VALUE, buffer);

		System.out.println("FactoryTime:  "+ Integer.toHexString(FactoryTime));
		System.out.println("HardSerial: "+ Integer.toHexString(HardSerial));
		System.out.println("ShipTime:   "+ Integer.toHexString(ShipTime));
		byte []ver1={(byte)(COSVersion>>24), (byte)(COSVersion>>16)};
		byte []ver2={(byte)(COSVersion>>8), (byte)COSVersion};
		String str1=new String(ver1);
		String str2=new String(ver2);
		System.out.println("COSVersion:   "+ str1+"."+str2);

		errcode = Rockey.DIC_Close(hic);
	}

}