// ==========================================================================
// Get supper password permission
// (1) the supper password is 8 bytes long, and should not enclose in end-user's software.
//      When the supper password is verified, you have the following permission
//      	a) creat or Delete excutable Files
//     	b) creat or Delete internal Files
//      	c) Format the ROCKEY(card)
//      	d) Reset supper password and Max password attempt 
//     	e) Get remote Update password
// (2) Demo ROCKEYpassword is FF FF FF FF FF FF FF FF
// (3) GET_CARD_PRIVILEGE is used to get different permission. the retuned 
//	value in cmddata shhow the status
//     DICPR_NOPASS     0       // supper password is not verified
//     DICPR_SUPERPASS  4       // supper password is verified
//     DICPR_REMOTEPASS 8       // remote update password is verified
// (4) User DIC_Get to get SUPERPASS_STATUS
//     SUPERPASS_STATUS 1     	//supper password is verified
//     SUPERPASS_STATUS 0     	//supper password is not verified
//     REMOTEPASS_STATUS is the same
// (5) when set supper password, you also need to set the max. attempt
// ==========================================================================

import java.io.*;

public class Sample8
{
	public Sample8()
	{
	}

	public static void main(String [] args)
	{
		int i, num, hic=0, errcode;
		byte[] cmddata=new byte[256];	// command buffer
		byte[] buffer=new byte[256];	// user buffer
		char[] name=new char[20];
		JavaRockey Rockey=new JavaRockey();
		
		num = Rockey.DIC_Find();
		for (i=0;i<num;i++)
		{
			hic = Rockey.DIC_Open(i, name);
			if (hic >= 0) break;		// find the first ROCKEY
		}
		if (i == num) return;
	
		// Get permission info
		errcode = Rockey.DIC_Command(hic, Rockey.GET_CARD_PRIVILEGE, cmddata);
		if (Rockey.DIC_Get(cmddata, Rockey.SUPERPASS_STATUS, Rockey.BY_VALUE, buffer)>0)
			System.out.print("Super password is verified\n");
		else System.out.print("Super password is not verified\n");
	
		// Super password is 8 FFs
		for (i=0;i<8;i++) cmddata[i] = (byte)0xff;
		errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
	
		// Get privilege information of the dongle
		errcode = Rockey.DIC_Command(hic, Rockey.GET_CARD_PRIVILEGE, cmddata);
		if (Rockey.DIC_Get(cmddata, Rockey.SUPERPASS_STATUS, Rockey.BY_VALUE, buffer)>0)
			System.out.print("Super password is verified\n");
		else System.out.print("Super password is not verified\n");
	
		//Set new super passwrod
		//copy new password (0 1 2 3 4 5 6 7) to buffer
		// p3 of DIC_Set is maximum retry numbers(10)
		for (i=0;i<8;i++) buffer[i] = (byte)i;
		Rockey.DIC_Set(cmddata, Rockey.SUPERPASS_DATA, Rockey.BY_ARRAY, 10, buffer);
		errcode = Rockey.DIC_Command(hic, Rockey.SET_SUPER_PASS, cmddata);
	
		// return to password not verified status
		errcode = Rockey.DIC_Close(hic);
		errcode = Rockey.DIC_Open(hic, name);
	
		// Check with new super passwrod.
		for (i=0;i<8;i++) cmddata[i] = (byte)i;
		errcode = Rockey.DIC_Command(hic, Rockey.CHECK_SUPER_PASS, cmddata);
	
		// Get privilege information of the dongle
		errcode = Rockey.DIC_Command(hic, Rockey.GET_CARD_PRIVILEGE, cmddata);
		if (Rockey.DIC_Get(cmddata, Rockey.SUPERPASS_STATUS, Rockey.BY_VALUE, buffer)>0)
			System.out.print("Super password is verified\n");
		else System.out.print("Super password is not verified\n");
	
		// restore super password to 8 FFs.
		for (i=0;i<8;i++) buffer[i] = (byte)0xff;
		Rockey.DIC_Set(cmddata, Rockey.SUPERPASS_DATA, Rockey.BY_ARRAY, 10, buffer);
		errcode = Rockey.DIC_Command(hic, Rockey.SET_SUPER_PASS, cmddata);
	
		errcode = Rockey.DIC_Close(hic);
	}

}