// ==========================================================================
// load ROCKEY dll
// ==========================================================================
#include <windows.h>
#include <stdio.h>
#include "dic32.h"

// function definition
typedef int (WINAPI *fDIC_Find)();
typedef int (WINAPI *fDIC_Open)(int hic, char* reader_name);
typedef int (WINAPI *fDIC_Close)(int hic);
typedef int (WINAPI *fDIC_Create)(char* filename, char* mfname, char* atr, WORD atrlen);
typedef int (WINAPI *fDIC_GetVersion)(char* ver);
typedef int (WINAPI *fDIC_Command)(int hic, int cmd, void* cmddata);
typedef int (WINAPI *fDIC_Get)(void* xdata, int p1, int p2, char* buffer);
typedef int (WINAPI *fDIC_Set)(void* xdata, int p1, int p2, int p3, char* buffer);

// definition
HINSTANCE hDll = NULL;		// dll handle
fDIC_Find		dDIC_Find;
fDIC_Open		dDIC_Open;
fDIC_Close		dDIC_Close;
fDIC_Create		dDIC_Create;
fDIC_GetVersion	dDIC_GetVersion;
fDIC_Command	dDIC_Command;
fDIC_Get		dDIC_Get;
fDIC_Set		dDIC_Set;

void main()
{
	int errcode;				// error code
	int num;				// number of ROCKEY
	int hic;				// device handle
	int i;
	
	// load dll
	hDll = LoadLibrary("DIC32U.DLL");
	if (hDll == NULL) return;
	dDIC_Find = (fDIC_Find)GetProcAddress(hDll, "DIC_Find");
	dDIC_Open = (fDIC_Open)GetProcAddress(hDll, "DIC_Open");
	dDIC_Close = (fDIC_Close)GetProcAddress(hDll, "DIC_Close");
	dDIC_Create = (fDIC_Create)GetProcAddress(hDll, "DIC_Create");
	dDIC_GetVersion = (fDIC_GetVersion)GetProcAddress(hDll, "DIC_GetVersion");
	dDIC_Command = (fDIC_Command)GetProcAddress(hDll, "DIC_Command");
	dDIC_Get = (fDIC_Get)GetProcAddress(hDll, "DIC_Get");
	dDIC_Set = (fDIC_Set)GetProcAddress(hDll, "DIC_Set");

	printf("searching ROCKEY: ");
	num = dDIC_Find();
	printf("%d\n",num);
	if (num <= 0)
	{
		printf("No ROCKEY found\n");
		return;
	}

	printf("Open ROCKEY\n");
	for (i=0;i<num;i++)
	{
		hic = dDIC_Open(i, NULL);	
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num)
	{
		printf("No ROCKEY found\n");
		return;
	}

	// ...
	// operate ROCKEY
	// ...

	printf("Close ROCKEY\n");
	errcode = dDIC_Close(hic);
	if (errcode != SCARD_S_SUCCESS)
	{
		printf("error code: %08x\n", errcode);
		return;
	}

	// unload dll
	FreeLibrary(hDll);
}
