// ==========================================================================
// Get super password permission
// (1) the super password is 8 bytes long, and should not enclose in end-user's software.
//      When the super password is verified, you have the following permission
//      	a) creat or Delete excutable Files
//     	b) creat or Delete internal Files
//      	c) Format the ROCKEY(card)
//      	d) Reset super password and Max password attempt 
//     	e) Get remote Update password
// (2) Demo ROCKEY's password is FF FF FF FF FF FF FF FF
// (3) GET_CARD_PRIVILEGE is used to get different permission. the retuned 
//	value in cmddata shhow the status
//    DICPR_NOPASS     0       ' super password is not verified
//     DICPR_SUPERPASS  4       ' super password is verified
//     DICPR_REMOTEPASS 8       ' remote update password is verified
// (4) User DIC_Get to get SUPERPASS_STATUS
//     SUPERPASS_STATUS 1     	'super password is verified
//     SUPERPASS_STATUS 0     	'super password is not verified
//     REMOTEPASS_STATUS is the same
// (5) when set super password, you also need to set the max. attempt
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int i, num, hic, errcode;
	char cmddata[256];	// command buffer
	char buffer[256];	// user buffer

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num) return;

	//get permission info
	errcode = DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
	if (DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, NULL))
		printf("super password is verified\n");
	else printf("super password is not verified\n");

	// Demo ROCKEY's password is FF FF FF FF FF FF FF FF
	for (i=0;i<8;i++) cmddata[i] = (char)0xff;
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// get permission info
	errcode = DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
	if (DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, NULL))
		printf("super password is verified\n");
	else printf("super password is not verified\n");

	// Set password
	// new paasword in buffer(0 1 2 3 4 5 6 7)
	// set max. attempt (10) in p3 of DIC_Set
	for (i=0;i<8;i++) buffer[i] = (char)i;
	DIC_Set(cmddata, SUPERPASS_DATA, BY_ARRAY, 10, buffer);
	errcode = DIC_Command(hic, SET_SUPER_PASS, cmddata);

	// cancel the super password permission
	errcode = DIC_Close(hic);
	errcode = DIC_Open(hic, NULL);

	// verify new super password
	for (i=0;i<8;i++) cmddata[i] = (char)i;
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);

	// read SUPERPASS_STATUS
	errcode = DIC_Command(hic, GET_CARD_PRIVILEGE, cmddata);
	if (DIC_Get(cmddata, SUPERPASS_STATUS, BY_VALUE, NULL))
		printf("super password is verified\n");
	else printf("super password is not verified\n");

	// reset password to FF FF FF FF FF FF FF FF
	for (i=0;i<8;i++) buffer[i] = (char)0xff;
	DIC_Set(cmddata, SUPERPASS_DATA, BY_ARRAY, 10, buffer);
	errcode = DIC_Command(hic, SET_SUPER_PASS, cmddata);

	errcode = DIC_Close(hic);
}
