// ==========================================================================
// Get manufacture and main volume info
// (1) A card has two main info, the first is ATR, and the other is main volume
// (2) ATR is generated automatically when file is created. In general, manufact
//     will write its info into ATR. The max. length of ATR is 15 bytes, and such
//     info can be read by DIC_OPEN.
// (3) The main volume of a card is 16 bytes, and such volume works as a driver name
// (4) DIC_Get will read the ATR or VOLUME info into its buffer, and the return of 
//     Dic_Get is the length of buffer.
// (5) Run GET_CARD_INFO with DIC_Command before DIC_Get.
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int i, num, hic, errcode;
	char cmddata[256];	// command buffer
	char buffer[256];	// user buffer

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		//  find the first ROCKEY
	}
	if (i == num) return;

	errcode = DIC_Command(hic, GET_CARD_INFO, cmddata);
	DIC_Get(cmddata, ATR, BY_ARRAY, buffer);	// abstract ATR from cmddata to buffer
	printf("ATR: %s\n", buffer);
	DIC_Get(cmddata, VOLUME, BY_ARRAY, buffer); // abstract main Volume from cmddata to buffer
	printf("VOLUME: %s\n", buffer);

	errcode = DIC_Close(hic);
}
