// ==========================================================================
// Get hardware info
// (1) harware info
//	a) FactoryTime, the Date that ROCKEY was made
//	b) HardSerial, gloablly unqiue hardware serial number
//	c) ShipTime, the Date the ROCKEY was sold
//	d) COSVersion, the Card operation system version
// (2) Use DIC_Get to get info, we can set the last parameter to NULL
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"

void main()
{
	int i, num, hic, errcode;
	char cmddata[256];	// command buffer
	DWORD FactoryTime, HardSerial, ShipTime, COSVersion;

	num = DIC_Find();
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);
		if (hic >= 0) break;		//  find the first ROCKEY
	}
	if (i == num) return;

	errcode = DIC_Command(hic, GET_HARDWARE_INFO, cmddata);
	FactoryTime = DIC_Get(cmddata, FACTORY_TIME, BY_VALUE, NULL);
	HardSerial = DIC_Get(cmddata, HARD_SERIAL, BY_VALUE, NULL);
	ShipTime = DIC_Get(cmddata, SHIP_TIME, BY_VALUE, NULL);
	COSVersion = DIC_Get(cmddata, COS_VERSION, BY_VALUE, NULL);
	printf("FactoryTime   %08X\n", FactoryTime);
	printf("HardSerial %08X\n", HardSerial);
	printf("ShipTime  %08X\n", ShipTime);
	printf("COSVersion   %c%c.%c%c\n", COSVersion>>24, COSVersion>>16, COSVersion>>8, COSVersion);

	errcode = DIC_Close(hic);
}
