// counter
// (1) set counter
// (2) start counter
// description
//  (1) if set the counter to 0, it means no limitation
//  (2) if the counter decreases to 0, the it stops and becomes invalid
// ==========================================================================

#include <windows.h>
#include <stdio.h>
#include "dic32.h"


void main(int argc, char* argv[])
{
	
	int i,num, hic, errcode,index;
	char cmddata[256];

	printf("searching ROCKEY: ");
	num = DIC_Find();
	if (num <= 0)
	{
		printf("No ROCKEY found\n");
		return;
	}
	printf("%d\n",num);

	printf("Open ROCKEY\n");
	for (i=0;i<num;i++)
	{
		hic = DIC_Open(i, NULL);	
		index = i;
		if (hic >= 0) break;		// find the first ROCKEY
	}
	if (i == num)
	{
		printf("No ROCKEY found\n");
		return;
	}
	
	memcpy(cmddata,"\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",8);		
	errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
	if (errcode != SCARD_S_SUCCESS) {
		printf("Verify Super Pass error : %8x\n",errcode);
	}

	//set counter
	DWORD dwMaxCounter = 5;
	errcode = DIC_Command(hic, SETCOUNTER, &dwMaxCounter);
	if(errcode != SCARD_S_SUCCESS)
	{
		printf("Set counter error %8x ",errcode);		
	}

	DIC_Close(hic);
	
	
//////////////////////////////////////////////////////////////////////////
	hic = DIC_Open(index,NULL);

	// STEPCOUNTER
	for(i=0; i<dwMaxCounter+1; i++)
	{
		errcode = DIC_Command(hic, STEPCOUNTER, NULL);
		if(errcode != SCARD_S_SUCCESS)
		{
			if(i>=dwMaxCounter)
			{
				printf(" i> dwMaxCounter\n");
				memcpy(cmddata,"\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF",8);		
				errcode = DIC_Command(hic, CHECK_SUPER_PASS, cmddata);
				if (errcode != SCARD_S_SUCCESS) {
					printf("Verify Super Pass error : %8x\n",errcode);
				}
				
				//if set the counter to 0, it means no limitation
				DWORD dwMaxCounter = 0;
				errcode = DIC_Command(hic, SETCOUNTER, &dwMaxCounter);
				if(errcode != SCARD_S_SUCCESS)
				{
					printf("Set counter error %8x ",errcode);		
				}
				
			}			
			else{
				printf("step counter error : %8x\n",errcode);			
			}
			
		}
	}

	DIC_Close(hic);
	
}
