/* 
RSA encryption/decryption
input: 128 bytes data
ouput: 255 cypher text and plaintext

*/

#include "sys_api.h"
#include "string.h"

void main()
{
int rPubFileID=0x1002;  //Rsa public key ID
int rPriFileID=0x1004;  //Rsa private key ID
word rKeyLength=1024;  //Rsa key length
unsigned char xdata tData[128]; //input data
unsigned char xdata outData[256]; //output data
int ret;

	//get data
	get_input(tData,0,0,128);

	//generate key pair
	ret=rsa_gen_key(rPubFileID,rKeyLength,rPriFileID);
	if(ret!=0)
		goto END;
	//RSA encryption
	ret=rsa_enc(rPubFileID,128,tData);
	if(ret!=0)
		goto END;
	memcpy(outData,tData,128);
	//RSA decryption
	ret=rsa_dec(rPriFileID,128,tData);
	if(ret!=0)
		goto END;
	memcpy(outData+128,tData,128);

	set_response(254,outData);
	exit();

END:
	set_response(2,&ret);
	exit();
}

