// CounterDlg.cpp : 
//

#include "stdafx.h"
#include "Counter.h"
#include "CounterDlg.h"
#include ".\counterdlg.h"

#include "dic32.h"
#pragma comment(lib,"dic32u.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

typedef union _FOUR_BYTE {

	struct {
		UCHAR Byte0;
		UCHAR Byte1;
		UCHAR Byte2;
		UCHAR Byte3;
	};

	ULONG AsULong;
} FOUR_BYTE, *PFOUR_BYTE;

#define REVERSE_LONG(Long) {            \
	UCHAR tmp;                          \
	PFOUR_BYTE l = (PFOUR_BYTE)(Long);  \
	tmp = l->Byte3;                     \
	l->Byte3 = l->Byte0;                \
	l->Byte0 = tmp;                     \
	tmp = l->Byte2;                     \
	l->Byte2 = l->Byte1;                \
	l->Byte1 = tmp;                     \
}


#define RUN_COUNTER_ID	0x6000


// 
int RunCount=0;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();


	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);   

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()






CCounterDlg::CCounterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCounterDlg::IDD, pParent)
	, m_wCounter(0)
	, m_strStatus(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCounterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_wCounter);
	DDV_MinMaxUInt(pDX, m_wCounter, 0, 1000000000);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strStatus);
}

BEGIN_MESSAGE_MAP(CCounterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_SETCOUNTER, OnBnClickedButtonSetcounter)
END_MESSAGE_MAP()




BOOL CCounterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	SetIcon(m_hIcon, TRUE);		
	SetIcon(m_hIcon, FALSE);		


	
	return TRUE;  
}

void CCounterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}



void CCounterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);


		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;


		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CCounterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CCounterDlg::OnBnClickedOk()
{
	int num=DIC_Find();
	int hic;
	int Ret=0;
	DWORD counterLeft;
	
	DICST_Before_Run_Data *bR=(DICST_Before_Run_Data *)new char[128];
	DICST_After_Run_Data *aR=(DICST_After_Run_Data *)bR;

	UpdateData();
	for(int i=0;i<num;i++)
	{
		hic=DIC_Open(i,NULL);
		if(hic>=0)
			break;
	}
	if(hic <0)
	{
		m_strStatus.Format("Can't find any card !");
		UpdateData(FALSE);
		return;
	}
	bR->RunID=RUN_COUNTER_ID;
	bR->ParaSize=0;
	Ret=DIC_Command(hic,RUN,bR);
	if(Ret)
	{
		m_strStatus.Format("Run file error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}
	//read the counter
	memcpy(&counterLeft,aR->Result,4);
	REVERSE_LONG(&counterLeft);

	m_strStatus.Format("The left counter is %d !",counterLeft);
	UpdateData(FALSE);
	RunCount++;
End:
	DIC_Close(hic);
	delete [] bR;
}


void CCounterDlg::OnBnClickedButtonSetcounter()
{
	int num=DIC_Find();
	int hic;
	int Ret=0;
	unsigned char pass[8]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
	
	UpdateData();
	for(int i=0;i<num;i++)
	{
		hic=DIC_Open(i,NULL);
		if(hic>=0)
			break;
	}
	if(hic <0)
	{
		m_strStatus.Format("Can't find any card !");
		UpdateData(FALSE);
		return;
	}
	//set the counter, super password is needed
	Ret=DIC_Command(hic,CHECK_SUPER_PASS,pass);
	if(Ret)
	{
		m_strStatus.Format("Check password error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}
	//set the counter
	Ret=DIC_Command(hic,SETCOUNTER,&m_wCounter);
	if(Ret)
	{
		m_strStatus.Format("Set counter error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}

	m_strStatus.Format("Success to set this counter !");
	UpdateData(FALSE);
	RunCount=0;
End:
	DIC_Close(hic);
	
}
