// TimerDlg.cpp : 
//

#include "stdafx.h"
#include "Timer.h"
#include "TimerDlg.h"
#include ".\timerdlg.h"

#include "dic32.h"
#pragma comment(lib,"dic32u.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define TIMER_FILE_ID	0x6001
#define CHECK_TIMER_ID	0x6002



class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);   


protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()






CTimerDlg::CTimerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimerDlg::IDD, pParent)
	, m_BeginTime(CTime::GetCurrentTime())
	, m_EndTime(CTime::GetCurrentTime())
	, m_strStatus(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTimerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER_START, m_BeginTime);
	DDX_DateTimeCtrl(pDX, IDC_DATETIMEPICKER_END, m_EndTime);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_strStatus);
	DDX_Control(pDX, IDC_DATETIMEPICKER_START, m_ctlBeginTime);
	DDX_Control(pDX, IDC_DATETIMEPICKER_END, m_ctlEndTime);
}

BEGIN_MESSAGE_MAP(CTimerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnBnClickedButtonSet)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()




BOOL CTimerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		
	
	m_ctlBeginTime.SetFormat("yyyy-MM-dd hh:mm:ss");
	m_ctlEndTime.SetFormat("yyyy-MM-dd hh:mm:ss");

	
	return TRUE;  
}

void CTimerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}



void CTimerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);


		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;


		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CTimerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTimerDlg::OnBnClickedOk()
{
	CTime t = CTime::GetCurrentTime();
	int num=DIC_Find();
	int hic;
	int Ret=0;
	unsigned char err;

	DICST_Before_Run_Data *bR=(DICST_Before_Run_Data *)new char[128];
	DICST_After_Run_Data *aR=(DICST_After_Run_Data *)bR;

	UpdateData();
	for(int i=0;i<num;i++)
	{
		hic=DIC_Open(i,NULL);
		if(hic>=0)
			break;
	}
	if(hic <0)
	{
		m_strStatus.Format("Can't find any card !");
		UpdateData(FALSE);
		return;
	}
	bR->RunID=CHECK_TIMER_ID;
	bR->ParaSize=6;
	//input date into dongle
	bR->Para[0]=t.GetYear();
	bR->Para[1]=t.GetMonth();
	bR->Para[2]=t.GetDay();
	bR->Para[3]=t.GetHour();
	bR->Para[4]=t.GetMinute();
	bR->Para[5]=t.GetSecond();

	Ret=DIC_Command(hic,RUN,bR);
	if(Ret)
	{
		m_strStatus.Format("Run file error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}
	// 1 byte return value. 0 success, non-0 erro, 255 wrong date
	err=aR->Result[0];
	if(err)
	{
		m_strStatus.Format("The time is invalid and return value is %d",err);
		UpdateData(FALSE);
		goto End;
	}
	m_strStatus.Format("The time is valid ");
	UpdateData(FALSE);
End:
	DIC_Close(hic);
	delete [] bR;
}

void CTimerDlg::OnBnClickedButtonSet()
{
	int num=DIC_Find();
	int hic;
	int Ret=0;
	unsigned char pass[8]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};
	DICST_Write_Data *wD=(DICST_Write_Data *)new char[128];
	DICST_File file;

	UpdateData();
	for(int i=0;i<num;i++)
	{
		hic=DIC_Open(i,NULL);
		if(hic>=0)
			break;
	}
	if(hic <0)
	{
		m_strStatus.Format("Can't find any card !");
		UpdateData(FALSE);
		return;
	}
	//verify super password
	Ret=DIC_Command(hic,CHECK_SUPER_PASS,pass);
	if(Ret)
	{
		m_strStatus.Format("Check password error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}

	file.fileatrpri=0x80;
	file.fileid=TIMER_FILE_ID;
	file.filecla=0xff;
	strcpy(file.filename,"");
	file.filesize=18;
	//create 18 bytes file
	Ret=DIC_Command(hic,CREATE_FILE,&file);
	if(Ret)
	{
		DIC_Command(hic,SET_CURRENT_FILE,&file);
		Ret=DIC_Command(hic,REMOVE_FILE,NULL);
		Ret=DIC_Command(hic,CREATE_FILE,&file);
	}
	if(Ret)
	{
		m_strStatus.Format("Create file error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}
	//set starting date
	wD->buffer[0]=m_BeginTime.GetYear();
	wD->buffer[1]=m_BeginTime.GetMonth();
	wD->buffer[2]=m_BeginTime.GetDay();
	wD->buffer[3]=m_BeginTime.GetHour();
	wD->buffer[4]=m_BeginTime.GetMinute();
	wD->buffer[5]=m_BeginTime.GetSecond();

	//set current date as the start
	wD->buffer[6]=m_BeginTime.GetYear();
	wD->buffer[7]=m_BeginTime.GetMonth();
	wD->buffer[8]=m_BeginTime.GetDay();
	wD->buffer[9]=m_BeginTime.GetHour();
	wD->buffer[10]=m_BeginTime.GetMinute();
	wD->buffer[11]=m_BeginTime.GetSecond();

	//set endding date
	wD->buffer[12]=m_EndTime.GetYear();
	wD->buffer[13]=m_EndTime.GetMonth();
	wD->buffer[14]=m_EndTime.GetDay();
	wD->buffer[15]=m_EndTime.GetHour();
	wD->buffer[16]=m_EndTime.GetMinute();
	wD->buffer[17]=m_EndTime.GetSecond();
	wD->offset=0;
	wD->size=18;
	Ret=DIC_Command(hic,WRITE_FILE,wD);
	if(Ret)
	{
		m_strStatus.Format("Write file error %X",Ret);
		UpdateData(FALSE);
		goto End;
	}
	m_strStatus.Format("Success to set this timer !");
	UpdateData(FALSE);
End:
	DIC_Close(hic);
	delete [] wD;
}



void CTimerDlg::OnBnClickedCancel()
{

	OnCancel();
}
