/*DIC32L.h
* inline definations of DIC_Commands, for the easier usage
*/

#ifndef __DIC32L_H
#define __DIC32L_H
namespace hbx{

extern inline int D32_RunExe(int hic,  // ROCKEY handle
					  WORD fileName, //exe file name
					  int dataSize,  //input data size
					  void *inData,  //inpute data
					  void *outData  //output data
					  );

extern inline int D32_WriteFile(int hic, //ROCKEY handle
						 WORD dataSize,     //data size
						 WORD offset,      //offset 
						 void*  data       //data							 
						 );


//DES encryption
extern inline int D32_DesEnc(IN int   hic,       //ROCKEY handle
				  IN WORD  fileID,        //DES key file ID 
				  IN BYTE keyID,          //Des key ID
				  IN OUT int *dataLength, //length of plaintext
				  IN BYTE *inData,        //input plaintext
				  OUT BYTE *outData       //output cypher text
				  );

//DES decryption
extern inline int D32_DesDec(IN int   hic,       //ROCKEY handle
				  IN WORD  fileID,        //DES key file ID 
				  IN BYTE keyID,          //Des key ID
				  IN OUT int *dataLength, //length of cypher text
				  IN BYTE *inData,        //input cypher text
				  OUT BYTE *outData       //output plaintext
				  );

//Gen RSA key
extern inline int D32_CreateRSAKey(IN int   hic,   //ROCKEY handle
				  IN WORD  pubKeyFileID,        //RSA public key file ID 
				  IN WORD  pivKeyFileID,        //RSA private key file ID 
				  IN WORD  pubKeySize       //key length 1024,512
					);

//RSA encryption
extern inline D32_RSAEnc(IN int   hic,       //ROCKEY handle
				  IN WORD  keyFileID,   //RSA key file ID , either public or private
				  IN OUT int *dataLength, //length of plaintext
				  IN BYTE *inData,        //input plaintext
				  OUT BYTE *outData       //output cypher text
				  );

//RSA decryption
extern inline D32_RSADec(IN int   hic,       //ROCKEY handle
				  IN WORD  keyFileID,   //RSA key file ID , either public or private
				  IN OUT int *dataLength, //length of cypher text
				  IN BYTE *inData,        //input cypher text
				  OUT BYTE *outData       //output plaintext
				  );

extern inline int D32_FormatCard(int hic);

extern int D32_CreateFile(int hic, USHORT id,byte attr=0x00,USHORT size=20, char *name="data", 
				   byte* g_progFile=NULL, byte _class=0xff);

extern void ErrorShowExit(int errcode, char* place="");
//error code and exit

extern int ErrorShow(int errcode, char* place="");
//error code


}//end NameSpace HBX

#endif //__DIC32L_H